--[[
	消息管理器
]]
MESSAGE =
{
	L_WINDOW_SHOW			= 1,
	L_WINDOW_REMOVE			= 2,
	L_WINDOW_ADD			= 3,
	L_WINDOW_CREATE			= 4,
	L_WINDOW_ACCEPT_KEY		= 5,

	SC_FeeRewardGetPrice  			= 201, --领取累计充值奖励
	JSON_SIGN						= 300, --签到
	JSON_REWARD						= 301, --补签
	JSON_TIMELIMIT					= 400, --新手充值活动领取奖励
	JSON_EVERYDAYRECHARGE			= 500, --每日充值
	JSON_EVERYDAYRECHARGE_REWARD	= 501, --每日领取
	JSON_BINDPHONE_CODE				= 600, --获取验证码
	JSON_BINDPHONE_BIND				= 601, --绑定手机
	JSON_CHARGE_SKIN_Receive		= 700, --充值活动领取奖励
	JSON_CHARGE_SKIN_Use			= 800, --替换皮肤
    JSON_CHARGE_SKIN_Get			= 801, --领取皮肤
    JSON_CHARGE_CUM_Get				= 901, --领取皮肤
    JSON_CHARGE_FUND_Get			= 1001, --领取基金

	CS_ACHIEVEMENT		= 1901,
	SC_ACHIEVEMENT		= 11901,
	CS_MAIL				= 2200,
	SC_MAIL				= 12200,
	CS_MONTH_CARD		= 2103,
	SC_MONTH_CARD		= 12103,
	CS_CHARGE			= 9951,
	SC_CHARGE			= 11124,
	SC_CHARGE_TEST		= 19951,
	CS_CHANGE_RIDDER	= 2104,
	CS_RETURN_DIAMOND	= 1126,
	SC_RETURN_DIAMOND	= 11126,
	CS_ACCEPT_DIAMOND	= 1127,
	SC_ACCEPT_DIAMOND	= 11127,
}

EVENT =
{
    SHARE_BUTTON_TAKE                   = "sharebutton_state_take",
    SHARE_BUTTON_SHARE                  = "sharebutton_state_share",
    SHARE_BUTTON_HAVETAKE				= "sharebutton_state_Have_take",
    SC_CHARGE_VISIBLEFALSE              = "charge_visiblefalse",
    SC_CHARGE_VISIBLETRUE               = "charge_visibletrue",
    SC_EVERYDAY_VISIBLETRUE             = "everyday_visibletrue",
	MODIFY_PLAYER_DATA					= "player_data_modify",
	MODIFY_PLAYER_CHARGE				= "player_charge_modify",
	REFREAH_DAY							= "refresh_day",
	DIAMOND_REDUCE						= "diamond_reduce",
    MESSAGEBOX_OK           			= "lua_supply_messagebox_ok",
    MESSAGEBOX_SIGN_UPPER_LIMIT_OK		= "lua_supply_messagebox_sign_upper_limit_ok",
    MESSAGEBOX_SUPPLY_UPPER_LIMIT_OK	= "lua_supply_messagebox_supply_upper_limit_ok",
    MESSAGEBOX_LIMIT_OK                 = "lua_reward_messagebox_ok",
    MESSAGEBOX_LIMIT_MAX                = "lua_reward_messagebox_max",
    REFRESH_VIEW						= "lua_refresh_view",
    REFRESH_EVERYDAY_VIEW				= "lua_refresh_everyday_view",
    EVERYDAY_LIMIT_OK                 	= "lua_everyday_messagebox_ok",
}

local MessageManager = class("MessageManager")

local s_instance = nil

-- Table m_messageContainer

-- 获取单例对象
function MessageManager.getInstance()
	if (s_instance == nil) then
		s_instance = MessageManager.new()
	end
	return s_instance
end

-- 构造函数
function MessageManager:ctor()
	self.m_messageContainer = {}
end

-- 析构函数
function MessageManager:dtor()
	self.m_messageContainer = nil
end

-- 注册消息 (消息类型，回调对象，回调函数)
function MessageManager:register(messageType, object, func)
	local message = self.m_messageContainer[messageType]
	local info = {obj = object, fun = func}
	if (message) then
		table.insert(message, info)
	else
		self.m_messageContainer[messageType] = {info}
	end
end

-- 注销消息 (消息类型，回调对象，回调函数)
function MessageManager:unregister(messageType, object, func)
	local message = self.m_messageContainer[messageType]
	if (message) then
		for i, info in ipairs(message) do
			if (info.obj == object and info.fun == func) then
				table.remove(message, i)
				break
			end
		end
	end
end

-- 注销所有消息
function MessageManager:unregisterAll()
	self.m_messageContainer = {}
end

-- 分发消息 (消息类型，消息数据)
function MessageManager:sendL( messageType, data )
	local message = self.m_messageContainer[messageType]
	if (message) then
		for i, info in ipairs(message) do
			info.fun(info.obj, messageType, data)
		end
	end
end

-- 向服务器发送消息
function MessageManager:sendS( messageType, data )
	sendMessageToServer(messageType, data)
end

-- 接收由C++底层传过来的网络消息
function recieveNetMessage( messageType, data )
	if (messageType < 1000) then
		data = json.decode(data)
	end
	s_instance:sendL(messageType, data)
end

-- 向服务器发送活动消息
function MessageManager:sendForJson( messageType, data )
	CPPInterfaceManager:GameNetRequest_SendJsonOperaitonMessageToServer(messageType, data)
end

function recieveJsonMessage( content )
	print("2101 data")
	print(content)
    local data = json.decode(content)

    if (data.ChargeTimes) then
    	 -- CPPInterfaceManager:DataPlayer_UnlockFlag(data.UnlockStatus)
    end
    if (data.UnlockStatus) then
    	for i,v in ipairs(data.UnlockStatus) do
    		CPPInterfaceManager:DataPlayer_UnlockFlag(v)
    	end
    end
    if (data.COWDataDownAllFeeData) then
    	dataFeeReward:pauseAllData(data.COWDataDownAllFeeData)
    end
    if (data.SignActivity) then
    	DataSign.init(data.SignActivity)
    end
    if (data.SkinActivity) then
    	DataTimeLimit.init(data.SkinActivity)
    end
    if (data.TeHuiActivity) then
    	DataEveryDayRecharge.init(data.TeHuiActivity)
    end
    if (data.PhoneActivity) then
    	DataBindPhone.init(data.PhoneActivity)
    end
    if (data.ChargeSkinActivity) then
    	DataChargeSkin.init(data.ChargeSkinActivity)
    end
    if (data.PlayerMercenary) then
    	local dataMercenary = json.decode(data.PlayerMercenary)
    	DataMercenary.init(dataMercenary)
    end
    if (data.ChargeRmbActivity) then
    	DataChargeCum.init(data.ChargeRmbActivity)
    end
    if (data.GrowthFundActivity) then
    	DataFund.init(data.GrowthFundActivity)
    end
end

return MessageManager
