local MILLISECOND_PER_DAY = 24 * 60 * 60 * 1000

Util = {}

function math.between( value, min, max )
    return math.max(min, math.min(max, value))
end

function Util.GetServerTime()
	return tonumber(getServerTime())
end

function Util.GetServerTimeInSecond()
	return tonumber(getServerTime()) / 1000
end

function Util.FormateRestTime( time )
	return formateRestTime(time)
end

function Util.Translate( key )
	return getStringInLang(key)
end

function Util.TranslateFormat( key, ... )
	return string.format(getStringInLang(key), ...)
end

function Util.TranslateArg( key, arg )
	return (string.gsub(getStringInLang(key), "{0}", arg))
end

function Util.SetSpriteFrame( obj, name )
	setSpriteFrameName(obj, name)
end

function Util.FormateTimeToDay( time )
	return ( time + 8 * 3600 ) / MILLISECOND_PER_DAY
end

function Util.ShowWarningMessage( key )
	ShowWarningMessageOnMessageLayer(key)
end

function Util.ShowNormalMessage( key, arg )
	if (arg) then
		ShowNormalMessageOnMessageLayer(string.gsub(getStringInLang(key), "{0}", arg))
	else
		ShowNormalMessageOnMessageLayer(getStringInLang(key))
	end
end

function Util.GetNationName( nation )
	return getNationName(nation)
end