--[[
	累计充值的数据模块
]]

DataChargeCum = {}

local s_chargeCumState = 0
local s_chargeCumNum = 0
local s_infoData = nil
local s_chargeCumReward = false
local s_chargeCumListNum = 0
local s_chargeCumTime = 0

local function updateChargeCum( allData )
	if (allData) then
		s_chargeCumState = allData.rmbStatus
		s_chargeCumNum = allData.rmbTotal
		s_chargeCumTime = allData.overTime
		s_infoData = {}
		s_chargeCumReward = false

		s_chargeCumListNum = table.nums(allData.rmbRewardArray)
		for i, data in ipairs(allData.rmbRewardArray) do  
		    if(data.status==1)then
		    	s_chargeCumReward = true
		    end
		    table.insert(s_infoData, data)
		end 
		if (s_chargeCumState~=1) then
			s_chargeCumReward = false
		end
	end
end

function DataChargeCum.init( allData )
	updateChargeCum(allData)
end

function DataChargeCum.update( allData )
	updateChargeCum(allData)
end

function DataChargeCum.getChargeCumListNum()
	return s_chargeCumListNum
end

function DataChargeCum.getChargeCumNum()
	return s_chargeCumNum
end

function DataChargeCum.getChargeCumTime()
	return s_chargeCumTime
end

function DataChargeCum.IsVisible()
	if (s_chargeCumState==1) then
		return true
	else
		return false
	end
end

function DataChargeCum.IsReward()
	return s_chargeCumReward
end

function DataChargeCum.getChargeCumInfo( index )
	return s_infoData[index]
end

function DataChargeCum_IsVisibleIcon()
	return s_chargeCumReward
end
