--[[
	累计充值奖励的数据模块
]]

local DataFeeReward = class("DataFeeReward")

local s_instance = nil


--奖励数据，对应ResourceRewardLogList
local s_rewardData = nil

--玩家数据，对应COWPlayerFeeState
local s_playerFeeData = nil

-- 获取单例对象
function DataFeeReward.getInstance()
	if (s_instance == nil) then
		s_instance = DataFeeReward.new()
	end
	return s_instance
end

-- 构造函数
function DataFeeReward:ctor()

end

-- 析构函数
function DataFeeReward:dtor()

end

-- 处理数据，对应的是COWDataDownAllFeeData数据
function DataFeeReward:pauseAllData(dataTable)
	if dataTable["resourceRewardLogList"] ~= nil then
		s_rewardData = dataTable["resourceRewardLogList"]
	else
		print("No resourceRewardLogList")
	end

	if dataTable["playerFeeData"] ~= nil then
		s_playerFeeData = dataTable["playerFeeData"]
	else
		print("No playerFeeData")
	end

--[[ 数据测试
	print(getRewardMaxStep())

	print(getStepDiamondRequest(1))

	print(json.encode(getStepRewardList(1)))

	print(getFeeDiamond())

	print(getCurStep)

	--2102 的 201操作，对应COWDataUpGetFeeReward
	data2102 = {}

	data2102["COWDataUpGetFeeReward"] = {}

	data2102["COWDataUpGetFeeReward"]["step"] = 1

	--测试2102
	requestStr = json.encode(data2102)
	print(requestStr)
	--messageManager:sendS(201,requestStr)
	]]
end

--奖励设定数据接口
--获取奖励总阶段
function getRewardMaxStep()
	return table.getn(s_rewardData)
end

function getStepDiamondRequest(step)
	return s_rewardData[step]["diamond"]
end

function getStepRewardList( step )
	return s_rewardData[step]["reward"]
end

--玩家数据接口
--获取已经领取的阶段
function getCurStep()
	return s_playerFeeData["curRewardStep"]
end

--获取充值获得的钻石
function getFeeDiamond()
	return s_playerFeeData["feeDiamond"]
end

return DataFeeReward

