--[[
	基金的数据模块
]]

DataFund = {}

local s_fundState = 1
local s_fundGetNum = 0
local s_fundSurplusNum = 0
local s_infoData = nil
local s_fundReward = false
local s_fundListNum = 10
local s_fundCharge = true
local s_fundTime = "2017.09.23-2017.09.30"

local function updateFund( allData )
	if (allData) then
		s_fundState = allData.growthStatus
		s_fundCharge = allData.isBuy
		s_fundTime = allData.overTime
		s_infoData = {}
		s_fundReward = false
		s_fundGetNum = 0
		s_fundSurplusNum = 0
		s_fundListNum = table.nums(allData.growthRewardArray)
		for i, data in ipairs(allData.growthRewardArray) do  	
		    if(data.status==1)then
		    	s_fundReward = true
		    elseif(data.status==2)then	
		    	s_fundGetNum = s_fundGetNum + data.reward
		    end
		    s_fundSurplusNum = s_fundSurplusNum + data.reward
		    table.insert(s_infoData, data)
		end 
		s_fundSurplusNum = s_fundSurplusNum - s_fundGetNum
		if (s_fundCharge==false) then
			s_fundReward = true
		end
		if (s_fundState~=1) then
			s_fundReward = false
		end
	end
end

function DataFund.init( allData )
	updateFund(allData)
end

function DataFund.update( allData )
	updateFund(allData)
end

function DataFund.getFundListNum()
	return s_fundListNum
end

function DataFund.getFundGetNum()
	return s_fundGetNum
end

function DataFund.getFundSurplusNum()
	return s_fundSurplusNum
end

function DataFund.getFundCharge()
	return s_fundCharge
end

function DataFund.getFundTime()
	return s_fundTime
end

function DataFund.IsVisible()
	if (s_fundState==1) then
		return true
	else
		return false
	end
end

function DataFund.IsReward()
	return s_fundReward
end

function DataFund.getFundInfo( index )
	return s_infoData[index]
end

function DataFund_IsVisibleIcon()
	return s_fundReward
end
