--[[
	数据管理器
]]

-- require("DataActivity")
require("DataTimeLimit")
require("DataSign")
require("DataShop")
require("DataRetDiamond")
require("DataEveryDayRecharge")
require("DataBindPhone")
require("DataChargeSkin")
require("DataMercenary")
require("DataChargeCum")
require("DataFund")


local DataManager = class("DataManager")

local s_instance = nil

-- 获取单例对象
function DataManager.getInstance()
	if (s_instance == nil) then
		s_instance = DataManager.new()
	end
	return s_instance
end

-- 构造函数
function DataManager:ctor()
	messageManager:register(MESSAGE.JSON_CHARGE_CUM_Get, self, self.refreshChargeCum)
	messageManager:register(MESSAGE.JSON_CHARGE_FUND_Get, self, self.refreshChargeFund)
	messageManager:register(MESSAGE.JSON_EVERYDAYRECHARGE_REWARD, self, self.refreshEveryDayRecharge)
	messageManager:register(MESSAGE.JSON_EVERYDAYRECHARGE, self, self.refreshEveryDayRecharge)
	messageManager:register(MESSAGE.JSON_TIMELIMIT, self, self.refreshTimeLimit)
	messageManager:register(MESSAGE.JSON_CHARGE_SKIN_Receive, self, self.refreshChargeSkin)
	messageManager:register(MESSAGE.JSON_BINDPHONE_BIND, self, self.refreshBindPhone)
	messageManager:register(MESSAGE.JSON_SIGN, self, self.refreshSign)
	messageManager:register(MESSAGE.JSON_REWARD, self, self.refreshSign)
	messageManager:register(MESSAGE.SC_RETURN_DIAMOND, self, self.refreshReturnDiamond)
	messageManager:register(MESSAGE.SC_ACCEPT_DIAMOND, self, self.refreshReturnDiamond)
	messageManager:register(EVENT.REFREAH_DAY, self, self.refreshDay)
end

-- 析构函数
function DataManager:dtor()
	messageManager:unregister(MESSAGE.JSON_CHARGE_FUND_Get, self, self.refreshChargeFund)
	messageManager:unregister(MESSAGE.JSON_CHARGE_CUM_Get, self, self.refreshChargeCum)
	messageManager:unregister(MESSAGE.JSON_EVERYDAYRECHARGE_REWARD, self, self.refreshEveryDayRecharge)
	messageManager:unregister(MESSAGE.JSON_EVERYDAYRECHARGE, self, self.refreshEveryDayRecharge)
	messageManager:unregister(MESSAGE.JSON_TIMELIMIT, self, self.refreshTimeLimit)
	messageManager:unregister(MESSAGE.JSON_CHARGE_SKIN_Receive, self, self.refreshChargeSkin)
	messageManager:unregister(MESSAGE.JSON_BINDPHONE_BIND, self, self.refreshBindPhone)
	messageManager:unregister(MESSAGE.JSON_SIGN, self, self.refreshSign)
	messageManager:unregister(MESSAGE.JSON_REWARD, self, self.refreshSign)
	messageManager:unregister(MESSAGE.SC_RETURN_DIAMOND, self, self.refreshReturnDiamond)
	messageManager:unregister(MESSAGE.SC_ACCEPT_DIAMOND, self, self.refreshReturnDiamond)
	messageManager:unregister(EVENT.REFREAH_DAY, self, self.refreshDay)
end

-- 收到签到的数据
function DataManager:refreshSign( messageType, data )
	DataSign.update(data.SignActivity)
end

function DataManager:refreshTimeLimit( messageType, data )
	DataTimeLimit.update(data.SkinActivity)
end

function DataManager:refreshChargeSkin( messageType, data )
    DataChargeSkin.update(data.ChargeSkinActivity)
end

function DataManager:refreshBindPhone( messageType, data )
	DataBindPhone.update(data.PhoneActivity)
end

function DataManager:refreshEveryDayRecharge( messageType, data )
	DataEveryDayRecharge.update(data.TeHuiActivity)
end

function DataManager:refreshChargeCum( messageType, data )
	DataChargeCum.update(data.ChargeRmbActivity)
end

function DataManager:refreshChargeFund( messageType, data )
	local data1 = json.decode(data)
	DataFund.update(data1.GrowthFundActivity)
end

-- 收到商店的数据
function DataManager:refreshShop( messageType, data )
	if (messageType == MESSAGE.SC_CHARGE or messageType == MESSAGE.SC_CHARGE_TEST) then
		DataShop.updateCharge(data)
	elseif (messageType == MESSAGE.SC_MONTH_CARD) then
		DataShop.updateMonthCard(data)
	end
end

-- 收到返钻的数据
function DataManager:refreshReturnDiamond( messageType, data )
	if (messageType == MESSAGE.SC_RETURN_DIAMOND) then
		DataRetDiamond.update(data)
	elseif (messageType == MESSAGE.SC_ACCEPT_DIAMOND) then
		DataRetDiamond.setAccepted(true)
	end
end

function DataManager:refreshDay( messageType, data )
	CPPInterfaceManager:GameNetRequest_SendCustomMessageToServer(0)
	
	DataShop.refreshDay()
end

return DataManager
