--[[
	签到的数据模块
]]

DataRetDiamond = {}

local boughtWeekCard = false
local boughtItems = {}
local isAccepted = false
local canAccept = false
local WeekCardReturn = 0
local WeekCardNum = 0
local WeekCardPrice = 0

function DataRetDiamond.init()
	canAccept = CPPInterfaceManager:DataPlayer_OpenChargeReward()
end

function DataRetDiamond.update( data )
	boughtWeekCard = false
    WeekCardNum = 0
    WeekCardPrice = 0
	canAccept = CPPInterfaceManager:DataPlayer_OpenChargeReward()
	isAccepted = data.finished
	boughtItems = {}
	for i, info in ipairs(data.chargeInfos) do
		local id = tonumber(info.hjItemId)
		local item, index = DataShop.getItemByID(id)
		if (DB_SHOP[index].month) then
			boughtWeekCard = true
			WeekCardReturn = info.diamond
            WeekCardNum = WeekCardNum + 1
            WeekCardPrice = DB_SHOP[index].price
		else
			local boughtItem = boughtItems[id]
			if (boughtItem) then
				boughtItem.buy = boughtItem.buy + 1
				boughtItem.diamond = boughtItem.diamond + info.diamond
			else
				boughtItems[id] = {buy = 1, diamond = info.diamond}
			end
		end
	end
end

function DataRetDiamond.setAccepted( param )
	isAccepted = param
end

function DataRetDiamond.canAccept()
	return canAccept
end

function DataRetDiamond.isAccepted()
	return isAccepted
end

function DataRetDiamond.getWeekCardPrice()
    return WeekCardPrice
end

function DataRetDiamond.isBoughtWeekCard()
	return boughtWeekCard
end

function DataRetDiamond.getBoughtItem( index )
	return boughtItems[index]
end

function DataRetDiamond.getBoughtDiamond()
	local diamond = 0
	for id, item in pairs(boughtItems) do
		local data, index = DataShop.getItemByID(id)
		diamond = diamond + DB_SHOP[index].count * item.buy
	end
	return diamond
end

function DataRetDiamond.getWeekCardNum()
    return WeekCardNum
end

function DataRetDiamond.getMonthDiamond()
	return WeekCardReturn
end

function DataRetDiamond.getReturnDiamond()
	local diamond = DataRetDiamond.getMonthDiamond()
	for id, item in pairs(boughtItems) do
		diamond = diamond + item.diamond
	end
	return diamond
end
