--[[
	签到的数据模块
]]

DataSign = {}

local s_signData = {}
local s_rewardData = nil
local s_newSign = false
local s_infoData = nil

local function updateSign( signData )
	if (signData) then
		s_signData.signCount = signData.signCount
		s_signData.supplyCount = signData.signSupplyCount
		s_signData.canSignToday = signData.canSignToday
		s_signData.supplyDiamond = signData.supplySignDiamondCost
		s_signData.todayNum = signData.todayNum

		s_infoData = {}
		local infoCount = table.nums(signData.signMap)
		for i = 1, infoCount do
			local info = signData.signMap[i]
			table.insert(s_infoData, info)
		end
	end
end

local function updateReward( rewardData )
	if (rewardData) then
		s_rewardData = {}
		local rewardCount = table.nums(rewardData)
		for i = 1, rewardCount do
			local reward = rewardData[tostring(i)]
			local data = {}
			for k, v in pairs(reward) do
				table.insert(data, {type = k, count = v})
			end
			table.insert(s_rewardData, data)
		end
	end
end

function DataSign.init( allData )
	updateSign(allData.PlayerSignData)
	updateReward(allData.RewardData)
end

function DataSign.update( allData )
	updateSign(allData.PlayerSignData)
	updateReward(allData.RewardData)
end

function DataSign.getSignCount()
	return s_signData.signCount or 0
end

function DataSign.getSupplyDiamond()
	return s_signData.supplyDiamond
end

function DataSign.getTodayNum()
	return s_signData.todayNum
end

function DataSign.getSupplyCount()
	return s_signData.supplyCount or 0
end

function DataSign.setSupplyCount(count)
	s_signData.supplyCount = count
end

function DataSign.canSignToday()
	return s_signData.canSignToday
end

function DataSign.setCanSignToday()
	s_signData.canSignToday = false
end

function DataSign.getSignInfo( index )
	return s_infoData[index]
end

function DataSign.getReward( index )
	return s_rewardData[index]
end

function DataSign.getRewardCount()
	return #s_rewardData
end

function DataSign.isNewSign()
	return s_newSign
end

function DataSign.setNewSign(isNewSign)
	s_newSign = isNewSign
end

function DataSign_IsVisibleIcon()
	return s_signData.canSignToday
end
