--[[
	限时充值的数据模块
]]

DataTimeLimit = {}

local s_timeLimitState = 1
local s_timeLimitChargeNum = 0
local s_infoData = nil
local s_timeLimitReward = false
local s_timeLimitListNum = 0
local s_timeLimitSkinName = ""

local function updateTimeLimit( allData )
	if (allData) then
		s_timeLimitState = allData.skinStatus
		s_timeLimitChargeNum = allData.skinDiamond
		s_timeLimitSkinName = allData.skinDefault
		s_infoData = {}
		s_timeLimitReward = false

		s_timeLimitListNum = table.nums(allData.skinArray)
		for i, data in ipairs(allData.skinArray) do  
		    if(data.status==1)then
		    	s_timeLimitReward = true
		    end
		    table.insert(s_infoData, data)
		end 
	end
end

function DataTimeLimit.init( allData )
	updateTimeLimit(allData)
end

function DataTimeLimit.update( allData )
	updateTimeLimit(allData)
end

function DataTimeLimit.getTimeLimitSkinName()
	return s_timeLimitSkinName
end

function DataTimeLimit.getTimeLimitListNum()
	return s_timeLimitListNum
end

function DataTimeLimit.getTimeLimitChargeNum()
	return s_timeLimitChargeNum
end

function DataTimeLimit.IsVisible()
	if (s_timeLimitState==1) then
		return true
	elseif(s_timeLimitState==2) then
		return s_timeLimitReward
	else
		return false
	end
end

function DataTimeLimit.IsReward()
	if(s_timeLimitState~=1 and s_timeLimitState~=2)then
		return false
	else
		return s_timeLimitReward
	end
	
end

function DataTimeLimit.getTimeLimitInfo( index )
	return s_infoData[index]
end

function DataTimeLimit_getTimeLimitState()
	return s_timeLimitState
end

function DataTimeLimit_IsVisibleIcon()
	return s_timeLimitReward
end