
local ActivityDailyShare = class("ActivityDailyShare", require("BaseView"))

local _super = ActivityDailyShare.super

local SIGN_DATE_ICON_COL_COUNT = 5
local SIGN_DATE_ICON_OFFSET_X = 35
local SIGN_DATE_ICON_OFFSET_Y = 35
local SIGN_DATE_ICON_DISTANCE_X = 55
local SIGN_DATE_ICON_DISTANCE_Y = 60
local SIGN_SCROLLVIEW_WIDTH = 300
local SIGN_SCROLLVIEW_HEIGHT = 170

local NEButtonData = AppData.NEButtonData
-- Table m_dateList
-- Bool m_isScrolling

function ActivityDailyShare:ctor()
	_super.ctor(self, "ui_huodong_fenxiang")
    print("ActivityDailyShare:ctor")
    self:initView()

    messageManager:register(EVENT.SHARE_BUTTON_TAKE, self, self.refreshButtonTake)
    messageManager:register(EVENT.SHARE_BUTTON_SHARE, self, self.refreshButtonShare)
    messageManager:register(EVENT.SHARE_BUTTON_HAVETAKE, self, self.refreshButtonHaveTake)
    messageManager:register(EVENT.MESSAGEBOX_LIMIT_OK, self, self.rewardHaveTake)
end

function ActivityDailyShare:dtor()
    --self.m_dateList = nil
--    self.m_isScrolling = nil
    messageManager:unregister(EVENT.SHARE_BUTTON_TAKE, self, self.refreshButtonTake)
    messageManager:unregister(EVENT.SHARE_BUTTON_SHARE, self, self.refreshButtonShare)
    messageManager:unregister(EVENT.SHARE_BUTTON_HAVETAKE, self, self.refreshButtonHaveTake)
    messageManager:unregister(EVENT.MESSAGEBOX_LIMIT_OK, self, self.rewardHaveTake)
    _super.dtor(self)
    print("ActivityDailyShare:dtor")
end

function ActivityDailyShare:switchState(state)
    local nodes = self.m_nodes
	if (state == 0) then
		--可分享，没奖可以领
		nodes.button:useSkin("F57")
		--nodes.btn:setEnabled(true)
		nodes.buttontitle:setString(getStringInLang("loc_share_battle_report_in_wechat"))
        nodes.reward1:playAnimation("pingshi")
        nodes.reward2:playAnimation("pingshi")
        nodes.reward1:getNodeByName("buqian"):setVisible(false)
        nodes.reward2:getNodeByName("buqian"):setVisible(false)
	elseif (state == 1) then
		--可领奖
		nodes.button:useSkin("F57")
		--nodes.btn:setEnabled(true)
		nodes.buttontitle:setString(getStringInLang("loc_share_everyday_title_2"))
        nodes.reward1:playAnimation("pingshi")
        nodes.reward2:playAnimation("pingshi")
        nodes.reward1:getNodeByName("buqian"):setVisible(false)
        nodes.reward2:getNodeByName("buqian"):setVisible(false)
	elseif (state == 2) then
		--已领奖
		nodes.button:useSkin("F62")
		--nodes.btn:setEnabled(false)
		nodes.buttontitle:setString(getStringInLang("loc_shop_item_name_month_card_reward_got"))
        nodes.reward1:playAnimation("yiqian")
        nodes.reward2:playAnimation("yiqian")
	end
end

function ActivityDailyShare:initView()
    local nodes = self.m_nodes
    local data = self.m_data
    rewardList = {}
    if self.m_rootNode then
        self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end

	nodes.title1 = self.m_rootNode:getLabelByName("text_title1")
	nodes.title2 = self.m_rootNode:getLabelByName("text_title2")
	nodes.textinfo = self.m_rootNode:getLabelByName("text_info")
	nodes.button = self.m_rootNode:getNodeByName("button")
	nodes.buttontitle = self.m_rootNode:getLabelByName("button/buttonLabel")	
	nodes.btn = self.m_rootNode:getNodeByName("btn")
	nodes.reward1 = self.m_rootNode:getNodeByName("reward1")
	nodes.reward2 = self.m_rootNode:getNodeByName("reward2")

	nodes.title1:setString(getStringInLang("loc_share_everyday_title_1"))
	nodes.title2:setString(getStringInLang("loc_share_everyday_title_2"))	
	nodes.textinfo:setString(getStringInLang("loc_share_everyday_ps"))
	self.m_rootNode:getLabelByName("reward1/title"):setString(getStringInLang("loc_achievement_reward"))
	self.m_rootNode:getLabelByName("reward2/title"):setString(getStringInLang("loc_achievement_reward"))

    self:getRewardList()

    local function buttonClick( sender )
        if (sender == nodes.btn) then
            local state = CPPInterfaceManager:DataPlayer_ShareWXButtonState()
            print("ActivityDailyShare:1")
            if (state == 0) then
                print("ActivityDailyShare:2")
                CPPInterfaceManager:DataPlayer_SendshareWXRewardButton()
            elseif (state == 1) then
                print("ActivityDailyShare:3")
                local isCeiling1 = self:checkCeiling(rewardList[1],rewardList[2])
                local isCeiling2 = self:checkCeiling(rewardList[3],rewardList[4])
                if (isCeiling1 or isCeiling2) then
                    print("ActivityDailyShare:4")
CPPInterfaceManager:UI_ShowMessageBox(0,"lua_reward_messagebox_ok","loc_mailbox_resource_overflow_title","loc_mailbox_resource_overflow_info")
                else
                    print("ActivityDailyShare:5")
                    self:rewardHaveTake()
                end
            elseif (state == 2) then
                CPPInterfaceManager:DataPlayer_SendshareWXRewardButton()
            end
        end
    end

    local stateInit = CPPInterfaceManager:DataPlayer_ShareWXButtonState()
    self:switchState(stateInit)
--	nodes.button

--    nodes.view = self.m_rootNode:getNodeByName("view")
--    nodes.sign = self.m_rootNode:getLabelByName("sign")
--    nodes.unsign = self.m_rootNode:getLabelByName("unsign")
--    nodes.signNum = self.m_rootNode:getLabelByName("signNum")
--    nodes.unsignNum = self.m_rootNode:getLabelByName("unsignNum")
--    nodes.btnSign = self.m_rootNode:getNodeByName("chargeButton")
--    nodes.btnSupply = self.m_rootNode:getNodeByName("chargeButton_1")
--    nodes.sign:setString(getStringInLang("loc_keep_sign_times_total"))
--    nodes.unsign:setString(getStringInLang("loc_keep_unsign_times_total"))
--    self.m_rootNode:getLabelByName("chargeAni/buttonLabel"):setString(getStringInLang("loc_keep_sign_button"))
--    self.m_rootNode:getLabelByName("chargeAni_1/buttonLabel"):setString(getStringInLang("loc_keep_sign_button_pay"))

    setNEButtonCallBack(nodes.btn, NEBattleEvent.NEButtonEventTouchUpInside, buttonClick)
    self:refresh()
end

function ActivityDailyShare:setPosition(x, y)
    self.m_rootNode:setPosition(cc.p(x, y))
end

function ActivityDailyShare:refresh()

end

function ActivityDailyShare:getRewardList()
    local nodes = self.m_nodes
    rewardStr = CPPInterfaceManager:DataPlayer_ShareWXRewardStr()
    rewardList = {}
    for rewardStr in string.gmatch(rewardStr, "(%d*),") do
        table.insert(rewardList, rewardStr)
    end
    nodes.reward1:getNodeByName("icon"):useSkin(tostring(rewardList[1]))
    nodes.reward2:getNodeByName("icon"):useSkin(tostring(rewardList[3]))
    nodes.reward1:getLabelByName("count"):setString(tostring(rewardList[2]))
    nodes.reward2:getLabelByName("count"):setString(tostring(rewardList[4]))
end

function ActivityDailyShare:rewardHaveTake()
    print("ActivityDailyShare:6")
    local nodes = self.m_nodes
    self:getRewardList()
    self:addRes(rewardList[1],rewardList[2])
    self:addRes(rewardList[3],rewardList[4])
    if (rewardList[1]~=22) then
        CPPInterfaceManager:UIEffect_FlyResourceIcon(nodes.reward1, 0, 0, rewardList[1], rewardList[2])
    end
    if (rewardList[3]~=22) then
        CPPInterfaceManager:UIEffect_FlyResourceIcon(nodes.reward1, 0, 0, rewardList[3], rewardList[4])
    end
    nodes.reward1:playAnimation("qiandao")
    nodes.reward2:playAnimation("qiandao")
    CPPInterfaceManager:DataPlayer_SendshareWXRewardButton()
end



function ActivityDailyShare:refreshButtonTake()
    self:switchState(1)
end

function ActivityDailyShare:refreshButtonShare()
    self:switchState(0)
    self:getRewardList()
end

function ActivityDailyShare:refreshButtonHaveTake()
    self:switchState(2)
end

function ActivityDailyShare:addRes(resid,num)
    if(tonumber(resid) == 1) then
        return CPPInterfaceManager:DataPlayer_AddGold(num)
    elseif(tonumber(resid) == 2) then
        return CPPInterfaceManager:DataPlayer_AddWood(num)
    elseif(tonumber(resid) == 3) then
        return CPPInterfaceManager:DataPlayer_AddOil(num)
    elseif(tonumber(resid) == 4) then
        return CPPInterfaceManager:DataPlayer_AddThirdRes(num)
    elseif(tonumber(resid) == 22) then
        return CPPInterfaceManager:DataPlayer_AddReputation(num)
    end
end

function ActivityDailyShare:checkCeiling(resid,num)
    if(tonumber(resid) == 1) then
        return CPPInterfaceManager:DataPlayer_CheckGoldCeiling(num)
    elseif(tonumber(resid) == 2) then
        return CPPInterfaceManager:DataPlayer_CheckWoodCeiling(num)
    elseif(tonumber(resid) == 3) then
        return CPPInterfaceManager:DataPlayer_CheckOilCeiling(num)
    elseif(tonumber(resid) == 4) then
        return CPPInterfaceManager:DataPlayer_CheckThirdResCeiling(num)
    elseif(tonumber(resid) == 22) then
        return false
    end
end

return ActivityDailyShare
