
local ActivityView = class("ActivityView", require("BaseView"))

local _super = ActivityView.super

local NEButtonData = AppData.NEButtonData

-- Function m_listener

function ActivityView:ctor()
	_super.ctor(self, "ui_huodong_qibing")
    print("ActivityView:ctor")
    self:initView()
end

function ActivityView:dtor()
    self.m_listener = nil
    _super.dtor(self)
    print("ActivityView:dtor")
end

function ActivityView:initView()
    local nodes = self.m_nodes
    local data = self.m_data

    if self.m_rootNode then
        self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end

    nodes.view = self.m_rootNode:getNodeByName("view")

    self.m_rootNode:getLabelByName("chargeBonus"):setString(getStringInLang("loc_first_charge_six_yuan"))
    self.m_rootNode:getLabelByName("ridder"):setString(getStringInLang("loc_first_charge_gift"))
    nodes.btnCharge = self.m_rootNode:getNodeByName("chargeButton")

    local function touchChargeEvent( sender )
        if self.m_listener then
            self.m_listener()
        end
    end

    setNEButtonCallBack(nodes.btnCharge, NEBattleEvent.NEButtonEventTouchUpInside, touchChargeEvent)
end

function ActivityView:setPosition(x, y)
    self.m_rootNode:setPosition(cc.p(x, y))
end

function ActivityView:getContentSize()
    return self.m_nodes.view:getContentSize()
end

function ActivityView:setListener( cbFunc )
    self.m_listener = cbFunc
end

return ActivityView
