
local BindPhone = class("BindPhone", require("BaseView"))

local _super = BindPhone.super


local NEButtonData = AppData.NEButtonData

function BindPhone:ctor()
	_super.ctor(self, "ui_huodong_bangdingshouji")
    print("BindPhone:ctor")
    self:initView()
    messageManager:register(MESSAGE.JSON_BINDPHONE_BIND, self, self.refeshBind)
end

function BindPhone:dtor()
    _super.dtor(self)
    print("BindPhone:dtor")
    messageManager:unregister(MESSAGE.JSON_BINDPHONE_BIND, self, self.refeshBind)
end

function BindPhone:initView()
    local nodes = self.m_nodes
    if self.m_rootNode then
        --self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end
    nodes.iconAni = self.m_rootNode:getNodeByName("iconAni")
    nodes.phoneView = self.m_rootNode:getNodeByName("phoneview")
    nodes.codeView = self.m_rootNode:getNodeByName("codeview")

    local function clickBind()
        local IsbindPhone = DataBindPhone.bindState()
        if(IsbindPhone==1) then
            CPPInterfaceManager:UI_ShowWarningMessage("loc_connect_cellphone_used_number",0)
        else
            messageManager:sendForJson(601, "")
            CPPInterfaceManager:DataPlayer_GoUserCenter()
        end
    end
    
    self.m_rootNode:getLabelByName("text_title"):setString(getStringInLang("loc_connect_cellphone_title"))
    self.m_rootNode:getLabelByName("text_info3"):setString(getStringInLang("loc_connect_cellphone_tips"))

    nodes.btnBind = self.m_rootNode:getNodeByName("btn_bind")
    self.m_rootNode:getLabelByName("ani_bind/buttonLabel"):setString(getStringInLang("loc_connect_cellphone_button"))

    local IsbindPhone = DataBindPhone.bindState()
    if(IsbindPhone==1) then
        nodes.aniBind = self.m_rootNode:getNodeByName("ani_bind")
        nodes.aniBind:useSkin("F62")
        self.m_rootNode:getLabelByName("ani_bind/buttonLabel"):setString(getStringInLang("loc_connect_cellphone_complete"))
    end
    local rewardNum = DataBindPhone.getbindPhoneListNum()
    for i=1,rewardNum do
        local data = DataBindPhone.getBindPhoneInfo( i )
        local dataType = data.type
        local dataValue = data.value
        local strres = "reward" .. tostring(i)
        local resAni = self.m_rootNode:getNodeByName(strres):setVisible(true)
        resAni:useSkin(tostring(dataType))
        resAni:getLabelByName("numLabel"):setString(tostring(dataValue))
    end

    setNEButtonCallBack(nodes.btnBind, NEBattleEvent.NEButtonEventTouchUpInside, clickBind)
end

function BindPhone:refeshBind()
    local nodes = self.m_nodes
    local IsbindPhone = DataBindPhone.bindState()
    if(IsbindPhone==1) then
        local rewardNum = DataBindPhone.getbindPhoneListNum()
        for i=1,rewardNum do
            local data = DataBindPhone.getBindPhoneInfo( i )
            local strres = "reward" .. tostring(i)
            local resAni = self.m_rootNode:getNodeByName(strres)
            local dataType = data.type
            local dataValue = data.value
            CPPInterfaceManager:UIEffect_FlyResourceIcon(resAni, 0, 0, dataType, dataValue)
        end
        nodes.aniBind = self.m_rootNode:getNodeByName("ani_bind")
        nodes.aniBind:useSkin("F62")
        self.m_rootNode:getLabelByName("ani_bind/buttonLabel"):setString(getStringInLang("loc_connect_cellphone_complete"))
        
    end
end

function BindPhone:addRes(resid,num)
    if(tonumber(resid) == 1) then
        return CPPInterfaceManager:DataPlayer_AddGold(num)
    elseif(tonumber(resid) == 2) then
        return CPPInterfaceManager:DataPlayer_AddWood(num)
    elseif(tonumber(resid) == 3) then
        return CPPInterfaceManager:DataPlayer_AddOil(num)
    elseif(tonumber(resid) == 4) then
        return CPPInterfaceManager:DataPlayer_AddThirdRes(num)
    elseif(tonumber(resid) == 22) then
        return CPPInterfaceManager:DataPlayer_AddReputation(num)
    elseif(tonumber(resid) == 11) then
        return CPPInterfaceManager:DataPlayer_AddDiamond(num)
    end
end

return BindPhone
