
local ChargeCum = class("ChargeCum", require("BaseView"))

local _super = ChargeCum.super

local TIMELIMIT_DATE_ICON_OFFSET_X = 0
local TIMELIMIT_DATE_ICON_OFFSET_Y = 6
local TIMELIMIT_DATE_ICON_DISTANCE_X = 300
local TIMELIMIT_DATE_ICON_DISTANCE_Y = 60
local TIMELIMIT_SCROLLVIEW_WIDTH = 300
local TIMELIMIT_SCROLLVIEW_HEIGHT = 178

local TIMELIMIT_NONE = 0
local TIMELIMIT_VERTICAL = 1
local TIMELIMIT_HORIZONTAL = 2
local TIMELIMIT_BOTH = 3

local NEButtonData = AppData.NEButtonData

function ChargeCum:ctor()
	_super.ctor(self, "ui_huodong_leijichongzhi")
    print("ChargeCum:ctor")
    self:initView()
    messageManager:register(MESSAGE.JSON_CHARGE_CUM_Get, self, self.refresh)
    messageManager:register(EVENT.REFRESH_VIEW, self, self.refresh)
end

function ChargeCum:dtor()
    self.m_isScrolling = nil
    _super.dtor(self)
    print("ChargeCum:dtor")
    messageManager:unregister(MESSAGE.JSON_CHARGE_CUM_Get, self, self.refresh)
    messageManager:unregister(EVENT.REFRESH_VIEW, self, self.refresh)
end

function ChargeCum:initView()
    local nodes = self.m_nodes
    self.m_dateList = {}
    self.m_InfoState = {}
    self.m_isScrolling = false

    if self.m_rootNode then
        --self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end
    local cumNum = DataChargeCum.getChargeCumNum()
    nodes.textinfo = self.m_rootNode:getLabelByName("text_info")
    nodes.textinfo:setString(getStringInLang(Util.TranslateArg("loc_activity_cumulative_recharge_already_charged", cumNum)))

    nodes.title = self.m_rootNode:getLabelByName("text_info2")
    nodes.title:setString(getStringInLang("loc_activity_cumulative_recharge_title"))

    nodes.btnPay = self.m_rootNode:getNodeByName("btn")
    self.m_rootNode:getLabelByName("button/buttonLabel"):setString(getStringInLang("loc_entershop"))


    local sview = ccui.ScrollView:create()
    sview:setDirection(TIMELIMIT_VERTICAL)
    sview:setAnchorPoint(cc.p(0, 0))
    sview:setScrollBarEnabled(false)
    sview:setContentSize(cc.size(TIMELIMIT_SCROLLVIEW_WIDTH, TIMELIMIT_SCROLLVIEW_HEIGHT))
    sview:setBounceEnabled(true)

    nodes.view = self.m_rootNode:getNodeByName("view")

    local function selectItem( sender )
        local index = sender:getTag()
        local dataChargeCum = DataChargeCum.getChargeCumInfo(index)
        local anim = self.m_dateList[index]

        if(dataChargeCum.status==0)then
            CPPInterfaceManager:UI_ShowWarningMessage("loc_activity_cumulative_recharge_charge_not_enough",0)
        elseif(dataChargeCum.status==2)then
            CPPInterfaceManager:UI_ShowWarningMessage("loc_share_reward_have_got",0)
        else
            rewardStr = dataChargeCum.reward
            rewardStr = rewardStr .. "|"
            rewardList = {}
            for rewardStr in string.gmatch(rewardStr, "(%d*)|") do
                table.insert(rewardList, rewardStr)
            end
            local itemId = 1
            local resListNum = table.nums(rewardList)
            for j = 1, resListNum do
                local resType = self:tableIdToResId(j)
                local resNum = rewardList[j]

                if(tonumber(resNum)~=0 and itemId<=4)then
                    local strName = "res_" .. tostring(itemId)
                    print("res_",itemId)
                    local resAnim = anim:getNodeByName(strName)
                    CPPInterfaceManager:UIEffect_FlyResourceIcon(resAnim, 0, 0, resType, resNum)
                    itemId = itemId + 1
                end
            end
            messageManager:sendForJson( 901, index )
        end 
    end

    local function openShop()
        --windowManager:removeUI("HuodongView")
        CPPInterfaceManager:WindowManger_OpenWindow("WINDOW_SHOP_UI")
    end

    local function scrollEnd( sender, eventType )
        if (eventType == TOUCH_EVENT_ENDED) then
            self.m_isScrolling = false
        end
    end

    local function scrollEvent( sender, eventType )
        if (eventType == SCROLLVIEW_EVENT_SCROLLING) then
            self.m_isScrolling = true
        end
    end

    local m_listNum = DataChargeCum.getChargeCumListNum()

    for i = 1, m_listNum do
        local data = DataChargeCum.getChargeCumInfo(i)
        local item = neanim.NEAnimNode:createNodeFromFile("ui_huodong_leijichongzhi_tiao.ani")
        local anim = item:getNodeByName("okAni")
        local button = item:getNodeByName("okBtn")

        local itemCum = data.addCondition
        local itemState = data.status
        rewardStr = data.reward
        rewardStr = rewardStr .. "|"
        rewardList = {}
        for rewardStr in string.gmatch(rewardStr, "(%d*)|") do
            table.insert(rewardList, rewardStr)
        end
        local itemId = 1
        local resListNum = table.nums(rewardList)
        for j = 1, resListNum do
            local resType = self:tableIdToResId(j)
            local resNum = rewardList[j]
            if(tonumber(resNum)~=0 and itemId<=4)then
                local strName = "res_" .. tostring(itemId)
                local resAnim = item:getNodeByName(strName)
                resAnim:useSkin(tostring(resType))
                resAnim:getLabelByName("numLabel"):setString(tostring(resNum))
                itemId = itemId + 1
            end
        end
        local k = itemId
        while(k<=4)
        do
            local strName = "res_" .. tostring(k)
            print("res_",k)
            local resAnim = item:getNodeByName(strName)
            if(resAnim)then
                resAnim:setVisible(false)
            end
            k = k + 1 
        end

        anim:getLabelByName("buttonLabel"):setString(getStringInLang("loc_mail_claim_button"))
        item:getLabelByName("label1"):setString(getStringInLang("loc_activity_charge_limited_time_need_charged"))
        item:getLabelByName("label2"):setString(getStringInLang(tostring(itemCum)))
        item:getLabelByName("label3"):setString(getStringInLang("loc_diamond"))


        item:setPosition(TIMELIMIT_DATE_ICON_DISTANCE_X/2+TIMELIMIT_DATE_ICON_OFFSET_X, m_listNum*TIMELIMIT_DATE_ICON_DISTANCE_Y-i* TIMELIMIT_DATE_ICON_DISTANCE_Y+TIMELIMIT_DATE_ICON_DISTANCE_Y/2)
        button:setTag(i)
        setNEButtonCallBack(button, NEBattleEvent.NEButtonEventTouchUpInside, selectItem)
        CPPInterfaceManager:NEButtonNode_SetSwallowTouches(button, false)
        sview:addChild(item)
        table.insert(self.m_dateList, item)
    end

    sview:addTouchEventListener(scrollEnd)
    sview:addEventListener(scrollEvent)
    sview:setInnerContainerSize(cc.size(TIMELIMIT_SCROLLVIEW_WIDTH, m_listNum*TIMELIMIT_DATE_ICON_DISTANCE_Y))
    nodes.view:addChild(sview, -1)
    setNEButtonCallBack(nodes.btnPay, NEBattleEvent.NEButtonEventTouchUpInside, openShop)

    self:refresh()
end

function ChargeCum:tableIdToResId(tableId)
    if(tableId==5)then
        return 11
    elseif(tableId>=6 and tableId<=8)then
        return tableId+35
    else
        return tableId
    end
end

function ChargeCum:refresh()
    print("ChargeCum:refresh")
    local nodes = self.m_nodes
    local cumNum = DataChargeCum.getChargeCumNum()
    nodes.textinfo:setString(getStringInLang(Util.TranslateArg("loc_activity_cumulative_recharge_already_charged", cumNum)))

    for i, date in ipairs(self.m_dateList) do
        local dataChargeCum = DataChargeCum.getChargeCumInfo(i)
        local anim = date:getNodeByName("okAni")
        if(dataChargeCum.status==0)then
            anim:useSkin("F65")
            anim:getLabelByName("buttonLabel"):setString(getStringInLang("loc_achievement_claim"))
        elseif(dataChargeCum.status==1)then
            anim:useSkin("F2")
            anim:getLabelByName("buttonLabel"):setString(getStringInLang("loc_achievement_claim"))
        elseif(dataChargeCum.status==2)then
            anim:useSkin("F65")
            anim:getLabelByName("buttonLabel"):setString(getStringInLang("loc_shop_item_name_month_card_reward_got"))
        end 
    end
end

return ChargeCum
