
local ChargeFund = class("ChargeFund", require("BaseView"))

local _super = ChargeFund.super

local NEButtonData = AppData.NEButtonData
local fundMessage = false
local Fund_DATE_ICON_OFFSET_X = 0
local Fund_DATE_ICON_OFFSET_Y = 6
local Fund_DATE_ICON_DISTANCE_X = 60
local Fund_DATE_ICON_DISTANCE_Y = 70
local Fund_SCROLLVIEW_WIDTH = 300
local Fund_SCROLLVIEW_HEIGHT = 136

function ChargeFund:ctor()
	_super.ctor(self, "ui_huodong_jijin")
    print("ChargeFund:ctor")
    self:initView()
    messageManager:register(MESSAGE.JSON_CHARGE_FUND_Get, self, self.refresh)
    messageManager:register(EVENT.REFRESH_EVERYDAY_VIEW, self, self.refresh)
end

function ChargeFund:dtor()
    self.m_isScrolling = nil
    _super.dtor(self)
    print("ChargeFund:dtor")
    messageManager:unregister(MESSAGE.JSON_CHARGE_FUND_Get, self, self.refresh)
    messageManager:unregister(EVENT.REFRESH_EVERYDAY_VIEW, self, self.refresh)
end

function ChargeFund:initView()
    local nodes = self.m_nodes
    self.m_dateList = {}
    self.m_isScrolling = false
    if self.m_rootNode then
        --self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end

    local sview = ccui.ScrollView:create()
    sview:setDirection(kCCScrollViewDirectionVertical)
    sview:setAnchorPoint(cc.p(0, 0))
    sview:setScrollBarEnabled(false)
    sview:setContentSize(cc.size(Fund_SCROLLVIEW_WIDTH, Fund_SCROLLVIEW_HEIGHT))
    sview:setBounceEnabled(true)

    nodes.view = self.m_rootNode:getNodeByName("view")

    local fundTime = DataFund.getFundTime()
    self.m_rootNode:getLabelByName("text_info2"):setString(getStringInLang(Util.TranslateArg("loc_growth_fund_activity_time", fundTime)))
    self.m_rootNode:getLabelByName("text_info3"):setString(getStringInLang("loc_growth_fund_10x_back"))
    self.m_rootNode:getLabelByName("text_info4"):setString(getStringInLang("loc_growth_fund_activity_intro"))
    fundMessage = DataFund.getFundCharge()
    nodes.btnPay = self.m_rootNode:getNodeByName("btn")
    local strShopItemName = CPPInterfaceManager:GetShopItemNameForId(18)
    self.m_rootNode:getLabelByName("button/buttonLabel"):setString(strShopItemName)
    local function selectItem( sender )
        local index = sender:getTag()
        local anim = self.m_dateList[index]
        local dataFund = DataFund.getFundInfo(index)
        local dataCharge = DataFund.getFundCharge()
        local resStatus = dataFund.status
        if(resStatus==0)then
            if(dataCharge)then
                CPPInterfaceManager:UI_ShowWarningMessage("loc_growth_fund_tips_wrong_level",0)
            else
                CPPInterfaceManager:UI_ShowWarningMessage("loc_growth_fund_tips_not_bought_yet",0)
            end
        elseif(resStatus==2)then
            CPPInterfaceManager:UI_ShowWarningMessage("loc_growth_fund_tips_already_get",0)
        else
            local resNum = dataFund.reward
            CPPInterfaceManager:UIEffect_FlyResourceIcon(anim, 0, 0, 11, resNum)
            messageManager:sendForJson( 1001, index )
        end 
    end

    local function openShop()
        local dataCharge = DataFund.getFundCharge()
        if(dataCharge)then
            CPPInterfaceManager:UI_ShowWarningMessage("loc_growth_fund_tips_already_bought",0)
        else
            messageManager:sendS(MESSAGE.CS_CHARGE, {shopID = 18})
        end
    end

    local function scrollEnd( sender, eventType )
        if (eventType == TOUCH_EVENT_ENDED) then
            self.m_isScrolling = false
        end
    end

    local function scrollEvent( sender, eventType )
        if (eventType == SCROLLVIEW_EVENT_SCROLLING) then
            self.m_isScrolling = true
        end
    end

    local m_listNum = DataFund.getFundListNum()

    for i = 1, m_listNum do
        local item = neanim.NEAnimNode:createNodeFromFile("ui_huodong_qiandaoneirong_button.ani")
        local anim = item:getNodeByName("icon")
        local resBtn = item:getNodeByName("iconButton")

        resBtn:setTag(i)
        setNEButtonCallBack(resBtn, NEBattleEvent.NEButtonEventTouchUpInside, selectItem)
        local col = i%5
        local lin = math.modf(i/5)+1
        if(i%5==0)then
            col = 5
            lin = lin-1
        end
        item:setPosition(Fund_DATE_ICON_DISTANCE_X*col-Fund_DATE_ICON_DISTANCE_X/2, (m_listNum/5)*Fund_DATE_ICON_DISTANCE_Y-lin* Fund_DATE_ICON_DISTANCE_Y+Fund_DATE_ICON_DISTANCE_Y/2+20)
        CPPInterfaceManager:NEButtonNode_SetSwallowTouches(resBtn, false)
        sview:addChild(item)
        table.insert(self.m_dateList, item)
    end

    sview:addTouchEventListener(scrollEnd)
    sview:addEventListener(scrollEvent)
    sview:setInnerContainerSize(cc.size(Fund_SCROLLVIEW_WIDTH, (m_listNum/5)*Fund_DATE_ICON_DISTANCE_Y+20))
    nodes.view:addChild(sview, -1)

    setNEButtonCallBack(nodes.btnPay, NEBattleEvent.NEButtonEventTouchUpInside, openShop)

    self:refresh()
end

function ChargeFund:refresh()
    print("ChargeFund:refresh")
    local dataCharge = DataFund.getFundCharge()
    if(fundMessage==false and dataCharge == true)then
        CPPInterfaceManager:UI_ShowWarningMessage("loc_growth_fund_tips_buy_succ",0)
    end
    if(dataCharge)then
        self.m_rootNode:getNodeByName("button"):useSkin("F60")
        self.m_rootNode:getLabelByName("button/buttonLabel"):setString(getStringInLang("loc_growth_fund_button_already_buy"))
    end
    fundMessage = dataCharge
    local nodes = self.m_nodes
    local fundGetNum = DataFund.getFundGetNum()
    local fundSurplusNum = DataFund.getFundSurplusNum()
    self.m_rootNode:getLabelByName("text_info"):setString(getStringInLang(Util.TranslateArg("loc_growth_fund_already_get", fundGetNum)))
    self.m_rootNode:getLabelByName("text_info1"):setString(getStringInLang(Util.TranslateArg("loc_growth_fund_still_left", fundSurplusNum)))
    for i, date in ipairs(self.m_dateList) do
        local dataFund = DataFund.getFundInfo(i)
        local resAnim = date:getNodeByName("icon")
        local resNum = dataFund.reward
        local resLevel = dataFund.level
        local resStatus = dataFund.status
    
        resAnim:getLabelByName("title"):setString(getStringInLang(Util.TranslateArg("loc_growth_fund_base_level", resLevel)))
        resAnim:getLabelByName("count"):setString(getStringInLang(Util.TranslateArg("loc_growth_fund_dimond_back", resNum)))

        resAnim:getLabelByName("label1"):setVisible(false)
        resAnim:getLabelByName("label2"):setVisible(false)

        if(dataCharge)then
            resAnim:getNodeByName("mask"):setVisible(false)
        else
            resAnim:getNodeByName("mask"):setVisible(true)
        end

        if(resStatus==0)then
            if(dataCharge)then
                resAnim:getLabelByName("label2"):setVisible(true)
                resAnim:getLabelByName("label2"):setString(getStringInLang("loc_growth_fund_state_wrong_level"))
            end
        elseif(resStatus==2)then
            resAnim:getLabelByName("label1"):setVisible(true)
            resAnim:getLabelByName("label1"):setString(getStringInLang("loc_growth_fund_state_already_get"))
        end 
    end
end

return ChargeFund
