local ChargeRidderView = class("ChargeRidderView", require("BaseView"))

local _super = ChargeRidderView.super

local NEButtonData = AppData.NEButtonData

function ChargeRidderView:ctor()
	_super.ctor(self, "ui_shouchong_chenggong", true)
    print("ChargeRidderView:ctor")
    -- self:createBackground(VIEW_BACKGROUND_NO_COLOR, true)
    self:setName("ChargeRidderView")
    self:initView()
end

function ChargeRidderView:dtor()
    _super.dtor(self)
    animManager:unusedSpriteframesFromPath("yasuo_shouchong_" .. Util.GetNationName(CPPInterfaceManager:DataPlayer_GetNation()))
    print("ChargeRidderView:dtor")
end

function ChargeRidderView:initView()
    local nodes = self.m_nodes
    local data = self.m_data

    if self.m_rootNode then
    	self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end

    nodes.imgRidder = self.m_rootNode:getNodeByName("ma")
    nodes.imgFlag = self.m_rootNode:getNodeByName("flagAnim")
    nodes.btnClose = self.m_rootNode:getNodeByName("buttonExit")
    nodes.btnChange = self.m_rootNode:getNodeByName("buttonOK")
    self.m_rootNode:getLabelByName("ok/buttonLabel"):setString(getStringInLang("loc_change_rider_now"))

    local nation = CPPInterfaceManager:DataPlayer_GetNation()
    local nationName = Util.GetNationName(nation)
    local plistName = "yasuo_shouchong_" .. nationName
    animManager:useSpriteframesFromPath(plistName)

    --Util.SetSpriteFrame(nodes.imgRidder, plistName .. "/info_s_nkvd_" .. nationName)
    if (nation == NATION_TYPE.NATION_TYPE_USA) then
        Util.SetSpriteFrame(nodes.imgRidder, plistName .. "/info_s_jinetes_" .. nationName)
    elseif (nation == NATION_TYPE.NATION_TYPE_GER) then
        Util.SetSpriteFrame(nodes.imgRidder, plistName .. "/info_s_savoia_" .. nationName)
    elseif (nation == NATION_TYPE.NATION_TYPE_SOV) then
        Util.SetSpriteFrame(nodes.imgRidder, plistName .. "/info_s_cossack_" .. nationName)
    elseif (nation == NATION_TYPE.NATION_TYPE_CHN) then
        Util.SetSpriteFrame(nodes.imgRidder, plistName .. "/info_s_nwcavalry_" .. nationName)
    end

    local skinName = nodes.imgFlag:getCurrentSkinName()
    local animName = nodes.imgFlag:getCurrentAnimName()
    nodes.imgFlag:changeFile("zc_flag_" .. nationName .. ".ani")
    nodes.imgFlag:playAnimation(animName)
    nodes.imgFlag:useSkin(skinName)

    local labText = self.m_rootNode:getLabelByName("text")
    local richLabel = custom.RichTextTrans:create()
    local size = labText:getDimensions()
    setRichTextParam(richLabel, labText)
    richLabel:setVAlignment(labText:getVerticalAlignment())
    richLabel:setHAlignment(labText:getHorizontalAlignment())
    richLabel:SetFontName("Arial-BoldMT")
    richLabel:SetFontSize(14)
    richLabel:SetFontColor(cc.c3b(255, 255, 255))
    richLabel:SetWord(getStringInLang("loc_elite_rider_unlock_1"))
    labText:setVisible(false)

    local function closeSelf()
        self:closeWindow("ChargeRidderView")
    end

    local function closeAndChange()
        self:closeWindow("ChargeRidderView")
        messageManager:sendS(MESSAGE.CS_CHANGE_RIDDER, {})
    end

    setNEButtonCallBack(nodes.btnClose, NEBattleEvent.NEButtonEventTouchUpInside, closeSelf)
    setNEButtonCallBack(nodes.btnChange, NEBattleEvent.NEButtonEventTouchUpInside, closeAndChange)
end

return ChargeRidderView
