
local ChargeSkin = class("ChargeSkin", require("BaseView"))

local _super = ChargeSkin.super

local TIMELIMIT_DATE_ICON_OFFSET_X = 0
local TIMELIMIT_DATE_ICON_OFFSET_Y = 6
local TIMELIMIT_DATE_ICON_DISTANCE_X = 90
local TIMELIMIT_DATE_ICON_DISTANCE_Y = 172
local TIMELIMIT_SCROLLVIEW_WIDTH = 300
local TIMELIMIT_SCROLLVIEW_HEIGHT = 180

local TIMELIMIT_NONE = 0
local TIMELIMIT_VERTICAL = 1
local TIMELIMIT_HORIZONTAL = 2
local TIMELIMIT_BOTH = 3

local NEButtonData = AppData.NEButtonData

function ChargeSkin:ctor()
	_super.ctor(self, "ui_huodong_pifu")
    print("ChargeSkin:ctor")
    self:initView()
    messageManager:register(MESSAGE.JSON_CHARGE_SKIN_Receive, self, self.refresh)
    messageManager:register(EVENT.REFRESH_VIEW, self, self.refresh)
end

function ChargeSkin:dtor()
    self.m_isScrolling = nil
    _super.dtor(self)
    print("ChargeSkin:dtor")
    messageManager:unregister(MESSAGE.JSON_CHARGE_SKIN_Receive, self, self.refresh)
    messageManager:unregister(EVENT.REFRESH_VIEW, self, self.refresh)
    animManager:unusedSpriteframesFromPath("yasuo_ui_" .. Util.GetNationName(CPPInterfaceManager:DataPlayer_GetNation()))
end

function ChargeSkin:initView()
    local nodes = self.m_nodes
    self.m_dateList = {}
    self.m_InfoState = {}
    self.m_isScrolling = false

    if self.m_rootNode then
        --self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end

    local nation = CPPInterfaceManager:DataPlayer_GetNation()
    local nationName = Util.GetNationName(nation)
    local plistName = "yasuo_ui_" .. nationName
    animManager:useSpriteframesFromPath(plistName)

    nodes.textinfo = self.m_rootNode:getLabelByName("text_info")
    nodes.textinfo:setString(getStringInLang("loc_activity_charge_limited_time_already_charged"))

    nodes.textnum = self.m_rootNode:getLabelByName("text_info1")

    nodes.title = self.m_rootNode:getLabelByName("text_info2")
    nodes.title:setString(getStringInLang("loc_activity_may_charge_activity_title"))

    nodes.tishi = self.m_rootNode:getLabelByName("text_info3")
    nodes.tishi:setString(getStringInLang("loc_activity_charge_tips"))

    nodes.btnPay = self.m_rootNode:getNodeByName("btn")
    self.m_rootNode:getLabelByName("button/buttonLabel"):setString(getStringInLang("loc_entershop"))


    local sview = ccui.ScrollView:create()
    sview:setDirection(TIMELIMIT_HORIZONTAL)
    sview:setAnchorPoint(cc.p(0, 0))
    sview:setScrollBarEnabled(false)
    sview:setContentSize(cc.size(TIMELIMIT_SCROLLVIEW_WIDTH, TIMELIMIT_SCROLLVIEW_HEIGHT))
    sview:setBounceEnabled(true)

    nodes.view = self.m_rootNode:getNodeByName("view")

    local function selectItem( sender )
        local index = sender:getTag()
        local dataTimeLimit = DataChargeSkin.getTimeLimitInfo(index)
        local anim = self.m_dateList[index]

        if(dataTimeLimit.status==2)then
            CPPInterfaceManager:UI_ShowWarningMessage("loc_share_reward_have_got",0)
        else
            CPPInterfaceManager:DataPlayer_AddDiamond(dataTimeLimit.addDiamond)
            CPPInterfaceManager:UIEffect_FlyResourceIcon(anim, 0, 0, 11, dataTimeLimit.addDiamond)
            messageManager:sendForJson( 700, index )
        end 
    end

    local function animFanye( sender )
        local index = sender:getTag()-10
        local infostate = self.m_InfoState[index]
        if (not infostate) then
            self.m_InfoState[index] = true
            local anim = self.m_dateList[index]
            local btnBg = anim:getNodeByName("bg_botton")
            anim:playAnimation("fanye")
            CPPInterfaceManager:NEButtonNode_SetSwallowTouches(btnBg, false)
        end
    end

    local function animFanye1( sender )
        if self.m_isScrolling then return end
        local index = sender:getTag()-20
        local infostate = self.m_InfoState[index]
        if (infostate==true) then
            self.m_InfoState[index] = false
            local anim = self.m_dateList[index]
            local btnBg = anim:getNodeByName("bg_botton")
            anim:playAnimation("fanye1")
            CPPInterfaceManager:NEButtonNode_SetSwallowTouches(btnBg, false)
        end
    end

    local function openShop()
        --windowManager:removeUI("HuodongView")
        CPPInterfaceManager:WindowManger_OpenWindow("WINDOW_SHOP_UI")
    end

    local function scrollEnd( sender, eventType )
        if (eventType == TOUCH_EVENT_ENDED) then
            self.m_isScrolling = false
        end
    end

    local function scrollEvent( sender, eventType )
        if (eventType == SCROLLVIEW_EVENT_SCROLLING) then
            self.m_isScrolling = true
        end
    end

    local m_listNum = DataChargeSkin.getTimeLimitListNum()

    for i = 1, m_listNum do
        local data = DataChargeSkin.getTimeLimitInfo(i)
        local skinname = DataChargeSkin.getTimeLimitSkinName()
        local item = neanim.NEAnimNode:createNodeFromFile("ui_huodong_pifu1.ani")
        local anim = item:getNodeByName("rewardAni")
        local button = item:getNodeByName("rewardButton")
        local btnInfo = item:getNodeByName("infoButton")
        local btnBg = item:getNodeByName("bg_botton")
        local icon = item:getNodeByName("icon")
        local unitId = data.modelId
        local addDiamond = data.addDiamond
        local addCondition = data.addCondition
        local strTitle = "loc_elite_army_skin_title_" .. tostring(unitId).."_" ..nation .."_"..skinname
        local strTitle1 = "loc_elite_army_skin_title2_" .. tostring(unitId).."_" ..nation .."_"..skinname
        local strInfo = "loc_elite_army_skin_content_" .. tostring(unitId).."_" ..nation .."_"..skinname
        local picname = CPPInterfaceManager:GetArmyCountryData_Picture(unitId,nation)
        

        anim:getLabelByName("buttonLabel"):setString(getStringInLang("loc_mail_claim_button"))
        item:getLabelByName("text_name"):setString(getStringInLang(strTitle))
        item:getLabelByName("text_reward"):setString(Util.TranslateArg("loc_activity_charge_limited_time_return_number", addDiamond))
        item:getLabelByName("text_num"):setString(getStringInLang(tostring(addCondition)))
        item:getLabelByName("text_info"):setString(getStringInLang("loc_activity_charge_limited_time_need_charged"))

        item:getLabelByName("title"):setString(getStringInLang(strTitle))
        item:getLabelByName("title1"):setString(getStringInLang(strTitle1))
        item:getLabelByName("res1"):setString(getStringInLang(strInfo))
        item:getLabelByName("res2"):setString(getStringInLang("loc_elite_army_skin_keep_time"))

        Util.SetSpriteFrame(icon,picname.."_"..skinname)
        item:setPosition((i - 1) * TIMELIMIT_DATE_ICON_DISTANCE_X+TIMELIMIT_DATE_ICON_DISTANCE_X/2+TIMELIMIT_DATE_ICON_OFFSET_X, TIMELIMIT_DATE_ICON_DISTANCE_Y/2+TIMELIMIT_DATE_ICON_OFFSET_Y)
        button:setTag(i)
        btnInfo:setTag(10+i)
        btnBg:setTag(20+i)
        CPPInterfaceManager:NEButtonNode_SetSwallowTouches(btnBg, false)
        setNEButtonCallBack(button, NEBattleEvent.NEButtonEventTouchUpInside, selectItem)
        setNEButtonCallBack(btnInfo, NEBattleEvent.NEButtonEventTouchUpInside, animFanye)
        setNEButtonCallBack(btnBg, NEBattleEvent.NEButtonEventTouchUpInside, animFanye1)
        sview:addChild(item)
        table.insert(self.m_InfoState, false)
        table.insert(self.m_dateList, item)
    end

    sview:addTouchEventListener(scrollEnd)
    sview:addEventListener(scrollEvent)
    sview:setInnerContainerSize(cc.size(4*TIMELIMIT_DATE_ICON_DISTANCE_X, TIMELIMIT_SCROLLVIEW_HEIGHT))
    nodes.view:addChild(sview, -1)
    setNEButtonCallBack(nodes.btnPay, NEBattleEvent.NEButtonEventTouchUpInside, openShop)

    self:refresh()
end

function ChargeSkin:refresh()
    print("ChargeSkin:refresh")
    local nodes = self.m_nodes
    local chargeNum = DataChargeSkin.getTimeLimitChargeNum()
    nodes.textnum:setString(getStringInLang(string.format(chargeNum)))
    for i, date in ipairs(self.m_dateList) do
        local dataTimeLimit = DataChargeSkin.getTimeLimitInfo(i)
        local labelNode = date:getNodeByName("labelNode")
        local anim = date:getNodeByName("rewardAni")
        labelNode:setVisible(false)
        anim:setVisible(true)
        if(dataTimeLimit.status==0)then
            labelNode:setVisible(true)
            anim:setVisible(false)
        elseif(dataTimeLimit.status==2)then
            anim:useSkin("F60")
            anim:getLabelByName("buttonLabel"):setString(getStringInLang("loc_shop_item_name_month_card_reward_got"))
        end 
    end
end

return ChargeSkin
