local ClientMessageBox = class("ClientMessageBox", require("BaseView"))

local _super = ClientMessageBox.super

local NEButtonData = AppData.NEButtonData

-- Bool m_needReload

function ClientMessageBox:ctor()
	_super.ctor(self, "ui_error_panel", true)
    print("ClientMessageBox:ctor")
    -- self:createBackground(VIEW_BACKGROUND_COLOR, true)
    --self:setIsAcceptBackKey(false)
    self:initView()
end

function ClientMessageBox:dtor()
    self.m_needReload = nil
    _super.dtor(self)
    print("ClientMessageBox:dtor")
end

function ClientMessageBox:initView()
    local nodes = self.m_nodes
    local data = self.m_data
    if self.m_rootNode then
    	self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end

    nodes.labTitle = self.m_rootNode:getLabelByName("titleLabel")
    nodes.labInfo = self.m_rootNode:getLabelByName("infoLabel")
    nodes.labTimeTitle = self.m_rootNode:getLabelByName("titleTime")
    nodes.labTimeInfo = self.m_rootNode:getLabelByName("infoTime")
    nodes.labOK = self.m_rootNode:getLabelByName("yesButtonAnim/buttonLabel")
    nodes.btnOK = self.m_rootNode:getNodeByName("yesButton")

    local function closeSelf( sender )
        if (sender == nodes.btnOK) then
            if (self.m_needReload) then
                dispatchReloadEvent(true)
            end
            self:closeWindow("ClientMessageBox")
        end
    end

    setNEButtonCallBack(nodes.btnOK, NEBattleEvent.NEButtonEventTouchUpInside, closeSelf)
end

function ClientMessageBox:refresh( type, param )
    self.m_needReload = true
    -- print("ClientMessageBox:refresh " .. type)
    self.m_nodes.labOK:setString(getStringInLang("loc_reload_game"))
    if (type == SYSTEM_MESSAGE.UNDER_ATTACK) then
        local function updateTime( dt )
            local nTime = self.m_EndTime - Util.GetServerTimeInSecond()
            if (nTime < 0) then
                self:closeWindow("ClientMessageBox")
                dispatchReloadEvent(true)
            else
                self.m_nodes.labTimeInfo:setString(Util.FormateRestTime(nTime))
            end
        end
        self.m_EndTime = Util.GetServerTimeInSecond() + math.max(param, 5)
        self.m_rootNode:playAnimation("Fighting")
        self.m_nodes.labTitle:setString(getStringInLang("loc_underattacking_error_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_underattacking_error"))
        self.m_nodes.labTimeTitle:setString(getStringInLang("loc_underattacking_error_count_down_title"))
        schedule(self.m_rootNode, updateTime, 0.5)
        self.m_needReload = false
    elseif (type == SYSTEM_MESSAGE.NO_OPERATION) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_hang_on_overtime_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_hang_on_overtime"))
    elseif (type == SYSTEM_MESSAGE.BE_ATTACK) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_underattack_error_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_underattack_error"))
    elseif (type == SYSTEM_MESSAGE.BE_CHANGE) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_multi_login_error_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_multi_login_error"))
    elseif (type == SYSTEM_MESSAGE.NET_BREAK) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_connectlogin_error_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_connectlogin_error"))
    elseif (type == SYSTEM_MESSAGE.SERVER_WILL_MAINTENANCE) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_maintaince_coming_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_maintaince_coming"))
    elseif (type == SYSTEM_MESSAGE.SERVER_MAINTENANCEING) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_maintaince_working_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_maintaince_working"))
    elseif (type == SYSTEM_MESSAGE.PLAYER_CHEAT) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_server_error_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_server_error"))
    end
end


return ClientMessageBox
