
local EveryDayRecharge = class("EveryDayRecharge", require("BaseView"))

local _super = EveryDayRecharge.super


local NEButtonData = AppData.NEButtonData

function EveryDayRecharge:ctor()
	_super.ctor(self, "ui_huodong_yiyuanzengyuanshuai")
    print("EveryDayRecharge:ctor")
    self:initView()
    messageManager:register(MESSAGE.JSON_EVERYDAYRECHARGE, self, self.haveCard)
    messageManager:register(EVENT.REFRESH_EVERYDAY_VIEW, self, self.havePay)
    messageManager:register(MESSAGE.JSON_EVERYDAYRECHARGE_REWARD, self, self.haveReward)
    messageManager:register(EVENT.EVERYDAY_LIMIT_OK, self, self.rewardRes)
    messageManager:register(EVENT.SC_EVERYDAY_VISIBLETRUE, self, self.payFail)
end

function EveryDayRecharge:dtor()
    _super.dtor(self)
    print("EveryDayRecharge:dtor")
    messageManager:unregister(MESSAGE.JSON_EVERYDAYRECHARGE, self, self.haveCard)
    messageManager:unregister(EVENT.REFRESH_EVERYDAY_VIEW, self, self.havePay)
    messageManager:unregister(MESSAGE.JSON_EVERYDAYRECHARGE_REWARD, self, self.haveReward)
    messageManager:unregister(EVENT.EVERYDAY_LIMIT_OK, self, self.rewardRes)
    messageManager:register(EVENT.SC_EVERYDAY_VISIBLETRUE, self, self.payFail)
end

function EveryDayRecharge:initView()
    local nodes = self.m_nodes

    if self.m_rootNode then
        --self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end
    nodes.iconAni = self.m_rootNode:getNodeByName("iconAni")

    local function clickPay()
        local IsRecharge = DataEveryDayRecharge.IsRecharge()
        local isRewardList = DataEveryDayRecharge.IsRewarList()
        if(isRewardList)then
            local rewardNum = DataEveryDayRecharge.RewardListNum()
            local isCeiling = false
            for i=1,rewardNum do
                local data = DataEveryDayRecharge.getRewardList( i )
                if(not isCeiling)then
                    isCeiling = self:checkCeiling(data.type,data.value)
                end
            end
            if(isCeiling)then
                CPPInterfaceManager:UI_ShowMessageBox(0,"lua_everyday_messagebox_ok","loc_mailbox_resource_overflow_title","loc_mailbox_resource_overflow_info")
            else
                self:rewardRes()
            end
        else
            if(IsRecharge)then
                CPPInterfaceManager:UI_ShowWarningMessage("loc_activity_continuous_recharge_already_buy",0)
            else
                nodes.aniPay:useSkin("F60")
                DataEveryDayRecharge.SetRechargeTrue(true)
                messageManager:sendS(MESSAGE.CS_CHARGE, {shopID = 9})
            end
        end
 
    end

    local function clickReward()
        local IsHaveCommander = CPPInterfaceManager:DataPlayer_IsHaveCommanderBuilding()
        if(IsHaveCommander)then
            messageManager:sendForJson( 500, 0 )
        else
            CPPInterfaceManager:UI_ShowWarningMessage("loc_activity_continuous_recharge_no_building",0)
        end
    end

    nodes.textinfo = self.m_rootNode:getLabelByName("text_info")

    self.m_rootNode:getLabelByName("text_info2"):setString(getStringInLang("loc_activity_continuous_recharge_title_1"))
    self.m_rootNode:getLabelByName("text_info3"):setString(getStringInLang("loc_activity_continuous_recharge_title_2"))
    self.m_rootNode:getLabelByName("text_info4"):setString(getStringInLang("loc_activity_continuous_recharge_content"))

    nodes.btnPay = self.m_rootNode:getNodeByName("btn")
    local strShopItemName = CPPInterfaceManager:GetShopItemNameForId(9)
    self.m_rootNode:getLabelByName("button/buttonLabel"):setString(strShopItemName)

    nodes.btnReward = self.m_rootNode:getNodeByName("btn1")
    self.m_rootNode:getLabelByName("button1/buttonLabel"):setString(getStringInLang("loc_mail_claim_button"))

    setNEButtonCallBack(nodes.btnPay, NEBattleEvent.NEButtonEventTouchUpInside, clickPay)
    setNEButtonCallBack(nodes.btnReward, NEBattleEvent.NEButtonEventTouchUpInside, clickReward)

    self:refresh()
end

function EveryDayRecharge:rewardRes()
    local nodes = self.m_nodes
    local rewardNum = DataEveryDayRecharge.RewardListNum()
    for i=1,rewardNum do
        local data = DataEveryDayRecharge.getRewardList( i )
            isCeiling = self:checkCeiling(data.type,data.value)
        CPPInterfaceManager:UIEffect_FlyResourceIcon(nodes.aniPay, 0, 0, data.type, data.value)
    end
    messageManager:sendForJson( 501, 0 )
end

function EveryDayRecharge:refresh()
    local nodes = self.m_nodes
    nodes.aniPay = self.m_rootNode:getNodeByName("button")
    nodes.aniReward = self.m_rootNode:getNodeByName("button1")
    nodes.aniJinDuTiao = self.m_rootNode:getNodeByName("jindutiao")
    nodes.commandiconAni = self.m_rootNode:getNodeByName("iconAni/icon")

    local commandId = DataEveryDayRecharge.getCommandId()
    local IsRecharge = DataEveryDayRecharge.IsRecharge()
    local infoNum = DataEveryDayRecharge.InfoDataNum()
    local isRewardList = DataEveryDayRecharge.IsRewarList()
    local rewardNum = DataEveryDayRecharge.RewardListNum()

    local chargeNum = DataEveryDayRecharge.getRechargeNum()
    nodes.textinfo:setString(getStringInLang(Util.TranslateArg("loc_activity_continuous_recharge_times", chargeNum)))

    if( commandId == -1 )then
        nodes.aniReward:setVisible(false)
        nodes.iconAni:playAnimation("wenhao")
    else
        nodes.iconAni:playAnimation("kapai")
        nodes.aniReward:setVisible(true)
        local strAttribute = CPPInterfaceManager:GetMarshalByID_Type(commandId)
        local strAttributeNum = CPPInterfaceManager:GetMarshalByID_Num(commandId)
        local pic = CPPInterfaceManager:GetMarshalByID_Icon(commandId)
        nodes.commandiconAni:getLabelByName("attribute_label"):setString(strAttribute)
        nodes.commandiconAni:getLabelByName("attribute_label_1"):setString(strAttributeNum)
        local icon = nodes.commandiconAni:getNodeByName("icon_ani/icon")
        Util.SetSpriteFrame(icon,pic)
    end

    if(isRewardList)then
        for i=1,rewardNum do
            local data = DataEveryDayRecharge.getRewardList( i )
            local strres = "res_" .. tostring(i)
            local strpic = "pic_"..tostring(i)
            local resAni = self.m_rootNode:getNodeByName(strres):setVisible(true)
            self.m_rootNode:getNodeByName(strpic):setVisible(true)

            resAni:useSkin(tostring(data.type))
            resAni:getLabelByName("numLabel"):setString(tostring(data.value))
        end
        nodes.aniPay:useSkin("F73")
        self.m_rootNode:getLabelByName("button/buttonLabel"):setString(getStringInLang("loc_mail_claim_button"))
    else
        local strShopItemName = CPPInterfaceManager:GetShopItemNameForId(9)
        self.m_rootNode:getLabelByName("button/buttonLabel"):setString(strShopItemName)
        if( IsRecharge )then
            nodes.aniPay:useSkin("F60")
        else
            nodes.aniPay:useSkin("F73")
        end
        for i=1,infoNum do
            local data = DataEveryDayRecharge.getEveryDayInfo( i )
            local strres = "res_" .. tostring(i)
            local strpic = "pic_"..tostring(i)
            local resAni = self.m_rootNode:getNodeByName(strres):setVisible(true)
            self.m_rootNode:getNodeByName(strpic):setVisible(true)

            resAni:useSkin(tostring(data.type))
            resAni:getLabelByName("numLabel"):setString(tostring(data.value))
        end
    end

    nodes.aniJinDuTiao:getNodeByName("respipe"):setContentSize(cc.size(38*chargeNum-1,9))
    
    for i=1,7 do
        local stricon = "imgDate_" .. tostring(i)
        local anim = nodes.aniJinDuTiao:getNodeByName(stricon)

        anim:getLabelByName("num"):setString(tostring(i))
        local chargeNum = DataEveryDayRecharge.getRechargeNum()
        if(i<=chargeNum)then
            anim:playAnimation("caise")
        end
    end
end

function EveryDayRecharge:haveCard()
    local nodes = self.m_nodes
    local commandId = DataEveryDayRecharge.getCommandId()
    if( commandId == -1 )then
        nodes.aniReward:setVisible(false)
        nodes.iconAni:playAnimation("fanpai1")
        CPPInterfaceManager:UI_ShowWarningMessage("loc_activity_get_reward",1)
    end
end

function EveryDayRecharge:payFail()
    local nodes = self.m_nodes
    nodes.aniPay:useSkin("F73")
    DataEveryDayRecharge.SetRechargeTrue(false)
end

function EveryDayRecharge:haveReward()
    local nodes = self.m_nodes
    local isRewardList = DataEveryDayRecharge.IsRewarList()
    local IsRecharge = DataEveryDayRecharge.IsRecharge()
    local infoNum = DataEveryDayRecharge.InfoDataNum()
    local rewardNum = DataEveryDayRecharge.RewardListNum()
    if(isRewardList)then
        for i=1,rewardNum do
            local data = DataEveryDayRecharge.getRewardList( i )
            local strres = "res_" .. tostring(i)
            local strpic = "pic_"..tostring(i)
            local resAni = self.m_rootNode:getNodeByName(strres):setVisible(true)
            self.m_rootNode:getNodeByName(strpic):setVisible(true)

            resAni:useSkin(tostring(data.type))
            resAni:getLabelByName("numLabel"):setString(tostring(data.value))
        end
        nodes.aniPay:useSkin("F73")
        self.m_rootNode:getLabelByName("button/buttonLabel"):setString(getStringInLang("loc_mail_claim_button"))
    else
        local strShopItemName = CPPInterfaceManager:GetShopItemNameForId(9)
        self.m_rootNode:getLabelByName("button/buttonLabel"):setString(strShopItemName)
        if( IsRecharge )then
            nodes.aniPay:useSkin("F60")
        else
            nodes.aniPay:useSkin("F73")
        end
        for i=1,infoNum do
            local data = DataEveryDayRecharge.getEveryDayInfo( i )
            local strres = "res_" .. tostring(i)
            local strpic = "pic_"..tostring(i)
            local resAni = self.m_rootNode:getNodeByName(strres):setVisible(true)
            self.m_rootNode:getNodeByName(strpic):setVisible(true)

            resAni:useSkin(tostring(data.type))
            resAni:getLabelByName("numLabel"):setString(tostring(data.value))
        end
    end


end

function EveryDayRecharge:havePay()
    local nodes = self.m_nodes
    local commandId = DataEveryDayRecharge.getCommandId()
    local chargeNum = DataEveryDayRecharge.getRechargeNum()
    local IsRecharge = DataEveryDayRecharge.IsRecharge()
    nodes.textinfo:setString(getStringInLang(Util.TranslateArg("loc_activity_continuous_recharge_times", chargeNum)))
    nodes.aniJinDuTiao:getNodeByName("respipe"):setContentSize(cc.size(38*chargeNum-1,9))

    if(chargeNum==7)then
        nodes.iconAni:playAnimation("fanpai")
        nodes.aniReward:setVisible(true)
        local strAttribute = CPPInterfaceManager:GetMarshalByID_Type(commandId)
        local strAttributeNum = CPPInterfaceManager:GetMarshalByID_Num(commandId)
        local pic = CPPInterfaceManager:GetMarshalByID_Icon(commandId)
        nodes.commandiconAni:getLabelByName("attribute_label"):setString(strAttribute)
        nodes.commandiconAni:getLabelByName("attribute_label_1"):setString(strAttributeNum)
        local icon = nodes.commandiconAni:getNodeByName("icon_ani/icon")
        Util.SetSpriteFrame(icon,pic)
    end

    local stricon = "imgDate_" .. tostring(chargeNum)
    local anim = nodes.aniJinDuTiao:getNodeByName(stricon)
    anim:playAnimation("qiandao")

    local isRewardList = DataEveryDayRecharge.IsRewarList()
    if(isRewardList)then
        nodes.aniPay:useSkin("F73")
        self.m_rootNode:getLabelByName("button/buttonLabel"):setString(getStringInLang("loc_mail_claim_button"))
    else
        local strShopItemName = CPPInterfaceManager:GetShopItemNameForId(9)
        self.m_rootNode:getLabelByName("button/buttonLabel"):setString(strShopItemName)
        if( IsRecharge )then
            nodes.aniPay:useSkin("F60")
        else
            nodes.aniPay:useSkin("F73")
        end
    end
end

function EveryDayRecharge:addRes(resid,num)
    if(tonumber(resid) == 1) then
        return CPPInterfaceManager:DataPlayer_AddGold(num)
    elseif(tonumber(resid) == 2) then
        return CPPInterfaceManager:DataPlayer_AddWood(num)
    elseif(tonumber(resid) == 3) then
        return CPPInterfaceManager:DataPlayer_AddOil(num)
    elseif(tonumber(resid) == 4) then
        return CPPInterfaceManager:DataPlayer_AddThirdRes(num)
    elseif(tonumber(resid) == 22) then
        return CPPInterfaceManager:DataPlayer_AddReputation(num)
    elseif(tonumber(resid) == 11) then
        return CPPInterfaceManager:DataPlayer_AddDiamond(num)
    end
end

function EveryDayRecharge:checkCeiling(resid,num)
    if(tonumber(resid) == 1) then
        return CPPInterfaceManager:DataPlayer_CheckGoldCeiling(num)
    elseif(tonumber(resid) == 2) then
        return CPPInterfaceManager:DataPlayer_CheckWoodCeiling(num)
    elseif(tonumber(resid) == 3) then
        return CPPInterfaceManager:DataPlayer_CheckOilCeiling(num)
    elseif(tonumber(resid) == 4) then
        return CPPInterfaceManager:DataPlayer_CheckThirdResCeiling(num)
    else
        return false
    end
end

return EveryDayRecharge
