
local MailView = class("MailView", require("BaseView"))

local _super = MailView.super

local NEButtonData = AppData.NEButtonData

function MailView:ctor()
	_super.ctor(self, "ui_mail")
    print("MailView:ctor")
    self:initView()
end

function MailView:dtor()
    messageManager:unregister(MESSAGE.SC_MAIL, self, self.refresh)
    _super.dtor(self)
    print("MailView:dtor")
end

function MailView:initView()
    local nodes = self.m_nodes
    local data = self.m_data

    if self.m_rootNode then
    	self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end

    nodes.btnClose = self.m_rootNode:getNodeByName("Panel/quitButton")
    self.m_rootNode:getLabelByName("LabelTitle"):setString("loc_mail_title")
    self.m_rootNode:getLabelByName("LabelSender"):setString("loc_mail_addresser_info")
    self.m_rootNode:getLabelByName("AnimDeleteAll/buttonLabel"):setString("loc_mail_button_delete_all")
    self.m_rootNode:getLabelByName("AnimCollectAll/buttonLabel"):setString("loc_mail_button_claim_all")

    local function closeSelf( sender )
        if sender == nodes.btnClose then
            self:closeWindow("MailView")
        end
    end

    setNEButtonCallBack(nodes.btnClose, NEBattleEvent.NEButtonEventTouchUpInside, closeSelf)
    messageManager:register(MESSAGE.SC_MAIL, self, self.refresh)
end

function MailView:refresh( messageType, data )
    print("messageType: " .. messageType)
    print("data count: " .. #data)
end

return MailView
