local MercenaryPackage = class("MercenaryPackage", require("BaseView"))

local _super = MercenaryPackage.super

local NEButtonData = AppData.NEButtonData

function MercenaryPackage:ctor(parent)
	_super.ctor(self, "ui_buy_diamond_panel", true)
    print("MercenaryPackage:ctor")
    self:setNeedMask(parent, true)
    self:createBackground(VIEW_BACKGROUND_NO_COLOR, true)
    self:setName("MercenaryPackage")
    self:initView()
end

function MercenaryPackage:dtor()
    _super.dtor(self)
    print("MercenaryPackage:dtor")
    animManager:unusedSpriteframesFromPath("yasuo_ui_" .. Util.GetNationName(CPPInterfaceManager:DataPlayer_GetNation()))
end

function MercenaryPackage:initView()
    local nodes = self.m_nodes
    local data = self.m_data

    if self.m_rootNode then
    	self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end

    local nation = CPPInterfaceManager:DataPlayer_GetNation()
    local nationName = Util.GetNationName(nation)
    local plistName = "yasuo_ui_" .. nationName
    animManager:useSpriteframesFromPath(plistName)

    self.m_rootNode:playAnimation("mtlibao")

    nodes.chargeAni = self.m_rootNode:getNodeByName("yesButtonAnim")
    nodes.btnClose = self.m_rootNode:getNodeByName("bg")
    nodes.btnCharge = self.m_rootNode:getNodeByName("yesButton")
    nodes.labTitle = self.m_rootNode:getLabelByName("titleLabel")
    nodes.btnLabel = nodes.chargeAni:getLabelByName("buttonLabel")
    nodes.label1 = self.m_rootNode:getLabelByName("label1")
    nodes.labelnum = self.m_rootNode:getLabelByName("labelnum")
    nodes.labelnum1 = self.m_rootNode:getLabelByName("labelnum1")
    nodes.labelnum2 = self.m_rootNode:getLabelByName("labelnum2")
    nodes.labelnewInfo = self.m_rootNode:getLabelByName("newInfo")

    nodes.bingAni = self.m_rootNode:getNodeByName("bingIcon")
    nodes.shuipianAni = self.m_rootNode:getNodeByName("shuipianIcon")

    local _MercenaryName = DataMercenary.getMercenaryName()
    local _MercenaryId = DataMercenary.getMercenaryId()
    local _Recharge = DataMercenary.getRecharge()
    local _ArmyType = DataMercenary.getArmyType()
    local _ArmyTime = DataMercenary.getArmyTime()
    local _Gem = DataMercenary.getGem()
    local _ItemType = DataMercenary.getItemType()
    local _ItemNum = DataMercenary.getItemNum()
    local _RechargeId = DataMercenary.getRechargeId()
    local picname = CPPInterfaceManager:GetArmyCountryData_modelPicture(_ArmyType,nation)
    local strShopItemName = CPPInterfaceManager:GetShopItemNameForId(_RechargeId)
    local icon = nodes.bingAni:getNodeByName("tex")

    nodes.shuipianAni:useSkin(tostring(_ItemType))

    local function closeSelf( sender )
        if (sender == nodes.btnClose) then
            self:closeWindow("MercenaryPackage")
        end
    end

    local function chargeEvent( sender )
        if (sender == nodes.btnCharge) then
            messageManager:sendS(MESSAGE.CS_CHARGE, {shopID=_RechargeId,mercenaryID=_MercenaryId})
            self:closeWindow("MercenaryPackage")
        end
    end
    
    nodes.labTitle:setString(getStringInLang(getStringInLang(_MercenaryName)))
    nodes.label1:setString(getStringInLang("loc_mercenary_give_away"))
    nodes.labelnum:setString(getStringInLang(tostring(_Gem)))
    nodes.labelnum1:setString(getStringInLang(Util.TranslateArg("loc_activity_left_day", _ArmyTime)))
    nodes.labelnum2:setString(getStringInLang(Util.TranslateArg("loc_mercenary_number", _ItemNum)))
    nodes.btnLabel:setString(getStringInLang(strShopItemName))
    nodes.labelnewInfo:setString(getStringInLang("loc_check_your_mercenary"))

    Util.SetSpriteFrame(icon,picname)

    --self:SetResPos(nodes.chargeAni)

    setNEButtonCallBack(nodes.btnClose, NEBattleEvent.NEButtonEventTouchUpInside, closeSelf)
    setNEButtonCallBack(nodes.btnCharge, NEBattleEvent.NEButtonEventTouchUpInside, chargeEvent)
end

function MercenaryPackage:SetResPos(node)
    local resNode = node:getNodeByName("resNode")
    if(resNode)then
        local resIcon = node:getNodeByName("resIcon")
        local numberLabel = node:getNodeByName("numberLabel")
        local x = resIcon:getContentSize().width * resIcon:getScale() + 5
        numberLabel:setPosition(x, numberLabel:getPositionY())
        local w = x + numberLabel:getContentSize().width * numberLabel:getScale()
        resNode:setPosition(-w*0.5, resNode:getPositionY())
    end
end

return MercenaryPackage
