
local SignView = class("SignView", require("BaseView"))

local _super = SignView.super

local SIGN_DATE_ICON_COL_COUNT = 5
local SIGN_DATE_ICON_OFFSET_X = 42
local SIGN_DATE_ICON_OFFSET_Y = 35
local SIGN_DATE_ICON_DISTANCE_X = 55
local SIGN_DATE_ICON_DISTANCE_Y = 60
local SIGN_SCROLLVIEW_WIDTH = 320
local SIGN_SCROLLVIEW_HEIGHT = 170

local signOrSupply_signNum = 0
local signOrSupply_supplyNum = 0
local supplyNum = 0

local NEButtonData = AppData.NEButtonData
-- Table m_dateList
-- Bool m_isScrolling

function SignView:ctor()
	_super.ctor(self, "ui_huodong_qiandao")
    print("SignView:ctor")
    self:initView()
    messageManager:register(MESSAGE.JSON_SIGN, self, self.refresh)
    messageManager:register(MESSAGE.JSON_REWARD, self, self.refresh)
    messageManager:register(EVENT.REFREAH_DAY, self, self.refresh)
    messageManager:register(EVENT.MESSAGEBOX_OK, self, self.confirmSupply)
    messageManager:register(EVENT.MESSAGEBOX_SIGN_UPPER_LIMIT_OK, self, self.confirmSignUpperLimit)
    messageManager:register(EVENT.MESSAGEBOX_SUPPLY_UPPER_LIMIT_OK, self, self.confirmSupplyUpperLimit)
end

function SignView:dtor()
    --self.m_dateList = nil
    self.m_isScrolling = nil
    messageManager:unregister(MESSAGE.JSON_SIGN, self, self.refresh)
    messageManager:unregister(MESSAGE.JSON_REWARD, self, self.refresh)
    messageManager:unregister(EVENT.REFREAH_DAY, self, self.refresh)
    messageManager:unregister(EVENT.MESSAGEBOX_OK, self, self.confirmSupply)
    messageManager:unregister(EVENT.MESSAGEBOX_SIGN_UPPER_LIMIT_OK, self, self.confirmSignUpperLimit)
    messageManager:unregister(EVENT.MESSAGEBOX_SUPPLY_UPPER_LIMIT_OK, self, self.confirmSupplyUpperLimit)
    _super.dtor(self)
    print("SignView:dtor")
end

function SignView:confirmSupply()
    local diamond = DataSign.getSupplyDiamond()
    local playerDiamond = CPPInterfaceManager:DataPlayer_GetDiamond()
    CPPInterfaceManager:DataPlayer_UseDiamond(tonumber(diamond))
    if ( tonumber(playerDiamond) >= tonumber(diamond) ) then
        for i, date in ipairs(self.m_dateList) do
            if(tonumber(supplyNum)==i) then
                signOrSupply_supplyNum = supplyNum
                local reward = DataSign.getReward(i)
                local anim = date:getNodeByName("icon")
                anim:playAnimation("qiandao")
                self:addRes(reward[1].type,reward[1].count)
                CPPInterfaceManager:UIEffect_FlyResourceIcon(anim, 0, 0, reward[1].type, reward[1].count)
                local count = DataSign.getSupplyCount()
                DataSign.setSupplyCount(DataSign.getSupplyCount()-1)
                if (DataSign.getSupplyCount() == 0) then
                    self.m_rootNode:getNodeByName("chargeAni_1"):useSkin("F60")
                end
                messageManager:sendForJson( 301, "" )
            end
        end
        self:setSupplyNum()
    end
end

function SignView:confirmSignUpperLimit()
    DataSign.setCanSignToday()
    local todayNum = DataSign.getTodayNum()
    for i, date in ipairs(self.m_dateList) do
        if(todayNum==i) then
            signOrSupply_signNum = todayNum
            local reward = DataSign.getReward(i)
            local anim = date:getNodeByName("icon")
            anim:playAnimation("qiandao")
            if (not DataSign.canSignToday()) then
                self.m_rootNode:getNodeByName("chargeAni"):useSkin("F60")
            end
            self:addRes(reward[1].type,reward[1].count)
            CPPInterfaceManager:UIEffect_FlyResourceIcon(anim, 0, 0, reward[1].type, reward[1].count)
            messageManager:sendForJson( 300, "" )
        end
    end
end

function SignView:confirmSupplyUpperLimit()
    local diamond = DataSign.getSupplyDiamond()
CPPInterfaceManager:UI_ShowMessageBox(tonumber(diamond),"lua_supply_messagebox_ok","loc_keep_sign_confirm_title","loc_keep_sign_confirm_info")
end

function SignView:setSupplyNum()
    for i, date in ipairs(self.m_dateList) do
        local info = DataSign.getSignInfo(i)
        if (tonumber(info) == 0) then
            if(tonumber(supplyNum) ~= i) then
                supplyNum = i
                break
            end
        end
    end
end

function SignView:checkCeiling(resid,num)
    if(tonumber(resid) == 1) then
        return CPPInterfaceManager:DataPlayer_CheckGoldCeiling(num)
    elseif(tonumber(resid) == 2) then
        return CPPInterfaceManager:DataPlayer_CheckWoodCeiling(num)
    elseif(tonumber(resid) == 3) then
        return CPPInterfaceManager:DataPlayer_CheckOilCeiling(num)
    elseif(tonumber(resid) == 4) then
        return CPPInterfaceManager:DataPlayer_CheckThirdResCeiling(num)
    end
end

function SignView:addRes(resid,num)
    if(tonumber(resid) == 1) then
        return CPPInterfaceManager:DataPlayer_AddGold(num)
    elseif(tonumber(resid) == 2) then
        return CPPInterfaceManager:DataPlayer_AddWood(num)
    elseif(tonumber(resid) == 3) then
        return CPPInterfaceManager:DataPlayer_AddOil(num)
    elseif(tonumber(resid) == 4) then
        return CPPInterfaceManager:DataPlayer_AddThirdRes(num)
    elseif(tonumber(resid) == 22) then
        return CPPInterfaceManager:DataPlayer_AddReputation(num)
    end
end

function SignView:initView()
    local nodes = self.m_nodes
    local data = self.m_data
    self.m_dateList = {}
    self.m_isScrolling = false

    supplyNum = 0
    signOrSupply_signNum = 0
    signOrSupply_supplyNum = 0

    if self.m_rootNode then
        self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end

    nodes.view = self.m_rootNode:getNodeByName("view")
    nodes.sign = self.m_rootNode:getLabelByName("sign")
    nodes.unsign = self.m_rootNode:getLabelByName("unsign")
    nodes.signNum = self.m_rootNode:getLabelByName("signNum")
    nodes.unsignNum = self.m_rootNode:getLabelByName("unsignNum")
    nodes.btnSign = self.m_rootNode:getNodeByName("chargeButton")
    nodes.btnSupply = self.m_rootNode:getNodeByName("chargeButton_1")
    nodes.sign:setString(getStringInLang("loc_keep_sign_times_total"))
    nodes.unsign:setString(getStringInLang("loc_keep_unsign_times_total"))
    self.m_rootNode:getLabelByName("chargeAni/buttonLabel"):setString(getStringInLang("loc_keep_sign_button"))
    self.m_rootNode:getLabelByName("chargeAni_1/buttonLabel"):setString(getStringInLang("loc_keep_sign_button_pay"))

    local sview = ccui.ScrollView:create()
    sview:setDirection(kCCScrollViewDirectionVertical)
    sview:setAnchorPoint(cc.p(0, 1))
    sview:setPosition(cc.p(-5, SIGN_SCROLLVIEW_HEIGHT+SIGN_DATE_ICON_OFFSET_Y+SIGN_DATE_ICON_COL_COUNT))
    sview:setScrollBarPositionFromCornerForVertical(cc.p(5, 0))
    sview:setContentSize(cc.size(SIGN_SCROLLVIEW_WIDTH, SIGN_SCROLLVIEW_HEIGHT))
    sview:setBounceEnabled(true)


    local function touchSupplyEvent( sender )
        if (sender == nodes.btnSupply) then
            if (DataSign.getSupplyCount() > 0 ) then
                local _supplynum = tonumber(supplyNum)
                local reward = DataSign.getReward(_supplynum)
                local isCeiling = self:checkCeiling(reward[1].type,reward[1].count)
                if(isCeiling) then
                    CPPInterfaceManager:UI_ShowMessageBox(0,"lua_supply_messagebox_supply_upper_limit_ok","loc_mailbox_resource_overflow_title","loc_mailbox_resource_overflow_info")
                else
                    self:confirmSupplyUpperLimit()
                end
            else
                CPPInterfaceManager:UI_ShowWarningMessage("loc_tips_nonSignIn",0)
            end
        end
    end

    local function touchSignEvent( sender )
        if (sender == nodes.btnSign) then
            local todayNum = DataSign.getTodayNum()
            if (DataSign.canSignToday()) then
                local _signnum = tonumber(todayNum)
                local reward = DataSign.getReward(_signnum)
                local isCeiling = self:checkCeiling(reward[1].type,reward[1].count)
                if(isCeiling) then
                    CPPInterfaceManager:UI_ShowMessageBox(0,"lua_supply_messagebox_sign_upper_limit_ok","loc_mailbox_resource_overflow_title","loc_mailbox_resource_overflow_info")
                else
                    self:confirmSignUpperLimit()
                end
            else
                CPPInterfaceManager:UI_ShowWarningMessage("loc_tips_signAlready",0)
            end
        end
    end

    -- local function onTouchDateIcon( sender )
    --     if self.m_isScrolling then return end

    --     local index = sender:getTag()
    --     if (DataSign.canSignToday() and index == DataSign.getSignCount() + 1) then
    --         messageManager:sendForJson( 300, "" )
    --     end
    -- end

    local function scrollEnd( sender, eventType )
        if (eventType == TOUCH_EVENT_ENDED) then
            self.m_isScrolling = false
        end
    end

    local function scrollEvent( sender, eventType )
        if (eventType == SCROLLVIEW_EVENT_SCROLLING) then
            self.m_isScrolling = true
        end
    end

    local dateCount = DataSign.getRewardCount()
    local rowCount = math.ceil(dateCount / SIGN_DATE_ICON_COL_COUNT)
    local height = math.max(rowCount * SIGN_DATE_ICON_DISTANCE_Y + 5, SIGN_SCROLLVIEW_HEIGHT)
    local index = 1
    for i = 1, rowCount do
        for j = 1, SIGN_DATE_ICON_COL_COUNT do
            if (index <= dateCount) then
                local item = neanim.NEAnimNode:createNodeFromFile("ui_huodong_qiandaoneirong_button.ani")
                local anim = item:getNodeByName("icon")
                local button = item:getNodeByName("iconButton")
                anim:setPosition(((j - 1) * SIGN_DATE_ICON_DISTANCE_X + SIGN_DATE_ICON_OFFSET_X), height - ((i - 1) * SIGN_DATE_ICON_DISTANCE_Y + SIGN_DATE_ICON_OFFSET_Y))
                anim:getLabelByName("title"):setString(string.format(getStringInLang("loc_keep_sign_tirty_days"), index))
                button:setTag(index)
                CPPInterfaceManager:NEButtonNode_SetSwallowTouches(button, false)
                -- setNEButtonCallBack(button, NEBattleEvent.NEButtonEventTouchUpInside, onTouchDateIcon)
                sview:addChild(item)
                table.insert(self.m_dateList, item)
            end
            index = index + 1
        end
    end
    sview:setInnerContainerSize(cc.size(SIGN_SCROLLVIEW_WIDTH, height))
    nodes.view:addChild(sview, -1)

    sview:addTouchEventListener(scrollEnd)
    sview:addEventListener(scrollEvent)
    setNEButtonCallBack(nodes.btnSupply, NEBattleEvent.NEButtonEventTouchUpInside, touchSupplyEvent)
    setNEButtonCallBack(nodes.btnSign, NEBattleEvent.NEButtonEventTouchUpInside, touchSignEvent)
    self:refresh()
end

function SignView:setPosition(x, y)
    self.m_rootNode:setPosition(cc.p(x, y))
end

function SignView:getContentSize()
	return self.m_nodes.view:getContentSize()
end

function SignView:refresh()
    local signCount = DataSign.getSignCount()
    local supplyCount = DataSign.getSupplyCount()
    local todayNum = DataSign.getTodayNum()

    self.m_nodes.signNum:setString(tostring(signCount))
    self.m_nodes.unsignNum:setString(tostring(DataSign.getSupplyCount()))
    
    for i, date in ipairs(self.m_dateList) do
        local reward = DataSign.getReward(i)
        local info = DataSign.getSignInfo(i)
        local anim = date:getNodeByName("icon")
        date:getLabelByName("icon/count"):setString("x" .. reward[1].count)
        if (tonumber(reward[1].type) > 0) then
            date:getNodeByName("icon/icon"):useSkin(reward[1].type)
        end
        anim:getNodeByName("mask"):setVisible(false)
        anim:getNodeByName("buqian"):setVisible(false)
        if (tonumber(info) > 0) then
            if(todayNum == i) then
                if(signOrSupply_signNum == 0) then
                    anim:playAnimation("yiqian")
                end
            else
                if(signOrSupply_supplyNum ~= i) then
                    anim:playAnimation("yiqian")
                end
            end
            anim:getNodeByName("mask"):setVisible(true)
        else
            if(tonumber(supplyNum) == 0) then
                supplyNum = i
            end
            anim:playAnimation("weiqian")
            if (todayNum > i) then
                anim:getNodeByName("buqian"):setVisible(true)
                anim:getLabelByName("buqianwenzi"):setString(getStringInLang("loc_keep_sign_button_pay"))
            end
        end
    end
    if (DataSign.getSupplyCount() == 0) then
        self.m_rootNode:getNodeByName("chargeAni_1"):useSkin("F60")
    end
    if (not DataSign.canSignToday()) then
        self.m_rootNode:getNodeByName("chargeAni"):useSkin("F60")
    end
end

return SignView
