local SystemMessageBox = class("SystemMessageBox", require("BaseView"))

local _super = SystemMessageBox.super

local NEButtonData = AppData.NEButtonData

-- Bool m_loadNow

function SystemMessageBox:ctor()
	_super.ctor(self, "ui_error_panel", true)
    _super.setZOrderLayer(11)
    print("SystemMessageBox:ctor")
    -- self:createBackground(VIEW_BACKGROUND_COLOR, true)
    self:initView()

end

function SystemMessageBox:dtor()
    self.m_loadNow = nil
    _super.dtor(self)
    print("SystemMessageBox:dtor")
end

function SystemMessageBox:initView()

    local nodes = self.m_nodes
    local data = self.m_data

    if self.m_rootNode then
    	self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end

    nodes.labTitle = self.m_rootNode:getLabelByName("titleLabel")
    nodes.labInfo = self.m_rootNode:getLabelByName("infoLabel")
    nodes.labOK = self.m_rootNode:getLabelByName("yesButtonAnim/buttonLabel")
    nodes.btnOK = self.m_rootNode:getNodeByName("yesButton")

    local function closeSelf( sender )
        if (sender == nodes.btnOK) then
            dispatchReloadEvent(self.m_loadNow)
            self:closeWindow("SystemMessageBox")
        end
    end

    self.m_loadNow = true
    setNEButtonCallBack(nodes.btnOK, NEBattleEvent.NEButtonEventTouchUpInside, closeSelf)
end

function SystemMessageBox:refresh( type, data )
    local strOK = ""
    if (data.reload) then
        strOK = getStringInLang("loc_reload_game")
    else
        strOK = getStringInLang("loc_confirm")
    end

    self.m_loadNow = data.reload
    self.m_nodes.labOK:setString(strOK)
    -- print("SystemMessageBox:refresh " .. type)
    if (type == SYSTEM_MESSAGE.WAIT_TO_LONG) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_connectingame_error_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_connectingame_error"))
        self.m_nodes.labOK:setString(getStringInLang("loc_retry"))
    elseif (type == SYSTEM_MESSAGE.SERVER_UNCATCH_ERROR) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_server_error_title"))
        self.m_nodes.labInfo:setString(Util.TranslateArg("loc_server_error", data.message))
    elseif (type == SYSTEM_MESSAGE.SERVER_ERROR) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_server_error_title"))
        self.m_nodes.labInfo:setString(data.message)
    elseif (type == SYSTEM_MESSAGE.NET_CLOSE) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_connect_error_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_connect_error"))
    elseif (type == SYSTEM_MESSAGE.TOKEN_ERROR) then
        self.m_nodes.labTitle:setString("登陆异常")
        self.m_nodes.labInfo:setString("Token非法不能登陆，退出游戏!!")
    elseif (type == SYSTEM_MESSAGE.TOKEN_WAIT_TO_LONG) then
        self.m_nodes.labTitle:setString("登陆异常")
        self.m_nodes.labInfo:setString("验证Token时间过长，退出游戏!!")
    elseif (type == SYSTEM_MESSAGE.ROBOT_NO_LOGIN) then
        self.m_nodes.labTitle:setString("登陆异常")
        self.m_nodes.labInfo:setString("玩家使用机器人账号登陆，退出游戏!!")
    elseif (type == SYSTEM_MESSAGE.PLAYER_CHEAT) then
        self.m_nodes.labTitle:setString("作弊了!!!")
        self.m_nodes.labInfo:setString("发现玩家修改了数据,退出游戏!!")
    elseif (type == SYSTEM_MESSAGE.SERVER_NO_RESPONCE) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_connectingame_error_title"))
        self.m_nodes.labInfo:setString(Util.TranslateArg("loc_connectingame_error", data.message))
    elseif (type == SYSTEM_MESSAGE.CANT_LOGIN) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_connectingame_error_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_connectingame_error"))
    elseif (type == SYSTEM_MESSAGE.BE_CHANGE) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_multi_login_error_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_multi_login_error"))
    elseif (type == SYSTEM_MESSAGE.RETURN_DIAMOND) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_server_error_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_server_test_return_already_claimed"))
    elseif (type == SYSTEM_MESSAGE.BE_ATTACK) then
        self.m_nodes.labTitle:setString(getStringInLang("loc_underattack_error_title"))
        self.m_nodes.labInfo:setString(getStringInLang("loc_underattack_error"))
    else
        self.m_nodes.labTitle:setString(getStringInLang(""))
        self.m_nodes.labInfo:setString(data.message)
    end
end

return SystemMessageBox
